package dbpatient;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class TSEvent implements Comparable<TSEvent>, Serializable
{
  private static final long serialVersionUID = 1L;

  static SimpleDateFormat sdf_ = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");

  // Timestamp value from the Oracle DB.
  public Date ts_;

  public TSEvent()
  {
    ts_ = null;
  }
  
  public TSEvent(Date ts)
  {
    ts_ = ts;
  }
  
  public void setTS(String tstamp)
  {
    try {
      ts_ = sdf_.parse(tstamp);
    }
    catch (ParseException e) {
      e.printStackTrace();
      System.exit(1);
    }
    catch (java.lang.NullPointerException e) {
      ts_ = null;
    }
  }
  
  public String getTS()
  {
    if (ts_ == null){
      return "";
    }
    else {
      return sdf_.format(ts_);
    }
  }
  
  public int compareTo(TSEvent event)
  {
    return ts_.compareTo(event.ts_);
  }
}
