package physiology;

import java.io.Serializable;
import java.util.Date;
import java.util.Vector;

import dbpatient.TSECarbRatio;

public class CarbRatioValues implements Serializable
{
  private static final long serialVersionUID = 1L;

  // Daily patterns.
  DailyPatternValues dpv_;

  public CarbRatioValues(Vector<TSECarbRatio> cr)
  {
    // Set daily patterns.
    dpv_ = new DailyPatternValues(cr);
    
    rewind();
  }
  
  
  public void rewind()
  {
    dpv_.rewind();
  }

  
  public Integer getCarbRatio(Date begin, Date end)
  {
    // Find daily pattern event, if any.
    TSECarbRatio cr = (TSECarbRatio) dpv_.getPatternEvent(begin, end);
    if (cr == null)
      return null;
    
    return cr.value_;
  }

}
