package physiology;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Vector;

import dbpatient.TSEvent;

public class DailyPattern implements Serializable
{
  private static final long serialVersionUID = 1L;

  // Day when pattern begins.
  Date start_;
  int day_;
  int month_;
  int year_;
  
  // Basal values, in chronological order.
  Vector<TSEvent> ts_values_;
  
  
  public DailyPattern(Date ts)
  {
    start_ = ts;
    GregorianCalendar gc = new GregorianCalendar();
    gc.setTime(ts);
    day_ = gc.get(Calendar.DAY_OF_MONTH);
    month_ = gc.get(Calendar.MONTH);
    year_ = gc.get(Calendar.YEAR);
    
    ts_values_ = new Vector<TSEvent>();
  }
  
  
  public void addEvent(TSEvent tse)
  {
    ts_values_.add(tse);
  }
  
  
  public TSEvent getEvent(Date ts)
  {
    assert start_.compareTo(ts) <= 0;
    
    GregorianCalendar gc = new GregorianCalendar();
    gc.setTime(ts);
    gc.set(year_, month_, day_);
    Date new_ts = gc.getTime();
    
    // Find corresponding time interval during the day i.e. [pos - 1, pos)
    int pos = 1;
    while (pos < ts_values_.size() && ts_values_.get(pos).ts_.before(new_ts))
      pos++;
    
    return ts_values_.get(pos - 1);
  }

}
