package physiology;

import java.io.Serializable;
import java.util.Date;
import java.util.Vector;

import dbpatient.TSEvent;

public class DailyPatternValues implements Serializable
{
  private static final long serialVersionUID = 1L;

  Vector<DailyPattern> daily_patterns_;
  int pos_bdp_;
  
  public DailyPatternValues(Vector<? extends TSEvent> events)
  {
    daily_patterns_ = new Vector<DailyPattern>();
    DailyPattern bdp = new DailyPattern(events.get(0).ts_);
    daily_patterns_.add(bdp);
    for (TSEvent tse: events) {
      DailyPattern bdp_new = new DailyPattern(tse.ts_);
      if (!sameDate(bdp, bdp_new)) {
        daily_patterns_.add(bdp_new);
        bdp = bdp_new;
      }
      bdp.addEvent(tse);
    }
    
    rewind();
  }
  
  
  protected boolean sameDate(DailyPattern bdp1, DailyPattern bdp2)
  {
    return bdp1.day_ == bdp2.day_ && bdp1.month_ == bdp2.month_ && bdp1.year_ == bdp2.year_;
  }
  
  
  public void rewind()
  {
    pos_bdp_ = 0;
  }

  
  public TSEvent getPatternEvent(Date begin, Date end)
  {
    // Find daily pattern event, if any.
    while (pos_bdp_ < daily_patterns_.size()) {
      DailyPattern bdp = daily_patterns_.get(pos_bdp_);
      if (end.before(bdp.start_))
        break;
      pos_bdp_++;
    }
    
    if (pos_bdp_ == 0)
      return null;
    else {
      DailyPattern bdp = daily_patterns_.get(pos_bdp_ - 1);
      return bdp.getEvent(end);
    }
  }
}
