package physiology;

import java.util.Date;

public class DeltaData
{
  // Time of previous BGL measurement.
  Date begin_;
  // Time of current BGL measurement.
  Date end_;
  
  // Glucose level, measured at time end_.
  Double bgl_;
  
  // Insulin delivered between [begin_, end_), from basal rate.
  Double basal_; 
  // Insulin delivered between [begin_, end_), from bolus.
  Double bolus_;
  // Carbs delivered between [begin_, end_), from meal.
  Double carbs_;
  
  // Parameter values, valid between [begin_, end_).
  Double insulin_sensitivity_;
  Integer carb_ratio_;
  
  public String toString()
  {
    StringBuilder sb = new StringBuilder();
    sb.append("begin = " + begin_ + " || " + "end = " + end_ + "\n");
    sb.append("BGL = " + bgl_);
    if (basal_ != null)
      sb.append(", Basal = " + basal_);
    if (bolus_ != null)
      sb.append(", Bolus = " + bolus_);
    if (carbs_ != null)
      sb.append(", Carbs = " + carbs_);
    // if (insulin_sensitivity_ != null)
    //   sb.append(", ISensitivity = " + insulin_sensitivity_);
    
    return sb.toString();
  }
}
