package physiology;

import java.io.Serializable;
import java.util.Date;
import java.util.Vector;

import dbpatient.TSEInsulinSensitivity;

public class InsulinSensitivityValues implements Serializable
{
  private static final long serialVersionUID = 1L;

  // Daily patterns.
  DailyPatternValues dpv_;

  public InsulinSensitivityValues(Vector<TSEInsulinSensitivity> is)
  {
    // Set daily patterns.
    dpv_ = new DailyPatternValues(is);
    
    rewind();
  }
  
  
  public void rewind()
  {
    dpv_.rewind();
  }

  
  public Double getInsulinSensitivity(Date begin, Date end)
  {
    // Find daily pattern event, if any.
    TSEInsulinSensitivity is = (TSEInsulinSensitivity) dpv_.getPatternEvent(begin, end);
    if (is == null)
      return null;
    
    return is.value_;
  }

}
