package physiology;

import java.io.Serializable;
import java.util.Date;
import java.util.Vector;

import dbpatient.TSEMeal;

public class MealValues implements Serializable
{
  private static final long serialVersionUID = 1L;

  // Meal events, in chronological order.
  Vector<TSEMeal> meals_;
  // Current position of meal event.
  int pos_;

  
  public MealValues(Vector<TSEMeal> meals)
  {
    meals_ = meals;
    
    rewind();
  }
  
  
  public void rewind()
  {
    pos_ = 0;
  }
  
  /**
   * Assume getCarbs() is called with intervals in chronological order.
   * 
   * @param begin
   * @param end
   * @return Amount of carbs consumed in interval [begin, end).
   */
  public Double getCarbs(Date begin, Date end)
  {
    // Find overlapping meal event, if any.
    while (pos_ < meals_.size()) {
      TSEMeal tse = meals_.get(pos_);
      if (tse.ts_.compareTo(begin) >= 0)
        break;
      pos_++;
    }
    
    if (pos_ >= meals_.size())
      return null;
    
    TSEMeal tse = meals_.get(pos_);
    if (tse.ts_.compareTo(end) >= 0)
      return null;
    
    return new Double(tse.carbs_);
  }
  
}
