package physiology;

import java.io.Serializable;
import java.util.Vector;

import Jama.Matrix;

public class PhysiologicalHistory implements Serializable
{
  private static final long serialVersionUID = 1L;

  static public class PhysiologicalStep implements Serializable 
  {
    private static final long serialVersionUID = 1L;

    DeltaData dd_;
    Matrix X_;
    Matrix P_;
    
    public PhysiologicalStep(DeltaData dd, Matrix X, Matrix P)
    {
      dd_ = dd;
      X_ = X;
      P_ = P;
    }
  }
  
  // Observation (dd) & State (X, P) transition history.
  Vector<PhysiologicalStep> steps_;

  
  public PhysiologicalHistory()
  {
    steps_ = new Vector<PhysiologicalStep>();
  }

  
  public void addStep(DeltaData dd, Matrix X, Matrix P)
  {
    steps_.add(new PhysiologicalStep(dd, X, P));
  }
  
}
