package BGPredict;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.GregorianCalendar;
import java.util.List;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileNotFoundException;
import util.DateUtil;
import util.DBUtil;
import Diabetes.DataObjects.Reading;
import Diabetes.DataObjects.BolusReading;
import Diabetes.DataObjects.BasalReading;
import java.sql.ResultSet;
import java.sql.SQLException;

public class ComputeExampleVector extends PredictionConfig{
  public ComputeExampleVector(int pid, GregorianCalendar gc, BufferedReader physiological_model, BufferedReader arima_models){
   evector = null;
   this.pid = pid;
   this.gc = gc;
   this.physiological_model = physiological_model;
   this.arima_models = arima_models;
  }
  protected int pid;
  protected GregorianCalendar gc;
  protected ExampleVector evector;
  protected BufferedReader physiological_model;
  protected BufferedReader arima_models;
  
  public ExampleVector getVector(){
   return evector;
  }
  public void computeVector(){

	int pred_time = LOOKAHEAD;

	List<Integer> physiological_indexes = new ArrayList<Integer>();

	physiological_indexes.add(LOOKAHEAD/5);
/*
	//Before prediction time
	for(int i = 1; i <= LOOKAHEAD/5; i++)
	{
		physiological_indexes.add(i);
	}

	//After Prediction time
	for(int i = LOOKAHEAD/5; i <= 12; i++)
	{
		physiological_indexes.add(i);
	}
	
	//All
	for(int i = 1; i <= 12; i++)
	{
		physiological_indexes.add(i);
	}
*/
	//physiological_indexes.add(6);
	physiological_indexes.add(12);
   evector = new ExampleVector(pid,gc);
   compute_target();
   compute_t0();

   compute_delta();

   compute_ind_physiological_model(physiological_indexes);

   compute_arima();

   //compute_linear_dawn_p();
   //compute_hours_asleep();
   //compute_nigel_dawn_p();
   //compute_quad_dawn_p();
   //compute_avg_dawn_p(pred_time);
   //compute_avg_diff_dawn_p(pred_time);
   //compute_arima_dawn_p(pred_time);
   //compute_phys_diff_dawn_p(pred_time);
   //compute_phys_dawn_p(pred_time);
   //compute_awake();


  }

	private void compute_target()
	{
		/*
		This function finds the true target value.
		This is needed for the training information and for checking how accurate the model is.
		This is not included as a feature in the testing point feature vectors.
		*/
   		GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
   		gc2.add(Calendar.MINUTE,LOOKAHEAD);

   		List<Reading> r30 = DBUtil.op_getCGMS(gc2,gc2);
   		if(r30.size() > 0)
		{	
			evector.vector.add(r30.get(0).getValue());
   		}
		else
		{
    			while(r30.size() == 0)
			{
			     gc2.add(Calendar.MINUTE,-5);
			     r30 = DBUtil.op_getCGMS(gc2,gc2);
			}
	
			evector.vector.add(r30.get(0).getValue());
   		}
   
  	}
  
  	private void compute_t0()
	{
   		List<Reading> r = DBUtil.op_getCGMS(gc,gc);
   		evector.vector.add(r.get(0).getValue()); 
  	}

	
  	private void compute_change()
	{
   		List<Reading> r0 = DBUtil.op_getCGMS(gc,gc);
   		GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
   		gc2.add(Calendar.MINUTE,30);
   		List<Reading> r30 = DBUtil.op_getCGMS(gc2,gc2);
   		evector.vector.add(r30.get(0).getValue() - r0.get(0).getValue());
  	}

  	private void compute_delta()
	{
   		List<Reading> r0 = DBUtil.op_getCGMS(gc,gc);
   		GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
   		GregorianCalendar gc3 = DateUtil.createGC(DateUtil.makeTS(gc));
   		gc2.add(Calendar.MINUTE,-60);
   		gc3.add(Calendar.MINUTE,-60);
   		List<Reading> r30 = DBUtil.op_getCGMS(gc2,gc);
   		int padding = 0;
   		int old_size = evector.vector.size();
   		for(int i = 0; i < r30.size(); ++i)
		{
    
    			if(!r30.get(i).getT().after(gc3))
			{
     				evector.vector.add(r30.get(i).getValue() - r0.get(0).getValue());
    			}
			else
			{
     				//System.out.println("padding");
     				++padding;
     				evector.vector.add(0.0);
     				--i;
    			}
    			gc3.add(Calendar.MINUTE,5);
   		}
   		if(padding > 0)
		{
    			//System.out.println("padding " + padding + " times for " + DateUtil.makeTS(gc));
   		}
   		int old_vector_size = evector.vector.size();
   		for(int i = old_size+12; i < evector.vector.size();)
		{
    			evector.vector.remove(i);
    			if(i > 15)
			{
    				 System.out.println("removing " + i );
    			}
   		}
   		if(evector.vector.size() > 15)
		{
    			System.out.println("vector size = " + evector.vector.size());
    			System.out.println("old vector size = " + old_size);
    			System.out.println("vector size before removing = " + old_vector_size);
   		}
   		//vector.remove(vector.size()-1);//remove last element
  	}

  private void compute_direction(){
    //List<Reading> r0 = DBUtil.getCGMS(pid,gc,gc,"cgms where");
    List<Reading> r0 = DBUtil.op_getCGMS(gc,gc);
    GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
    gc2.add(Calendar.MINUTE,-25);
    //List<Reading> r25 = DBUtil.getCGMS(pid,gc2,gc,"cgms where");
    List<Reading> r25 = DBUtil.op_getCGMS(gc2,gc);
    int total = 0;
    for(int i = 0; i < r25.size(); ++i){
     total += r25.get(i).getValue();
    }
    double average = total * 1.0 / r25.size();
    int dead_zone = 10;
    if(average < r0.get(0).getValue() - dead_zone){
     evector.vector.add(-1.0);
    }else if(average > r0.get(0).getValue() + dead_zone){
     evector.vector.add(1.0);
    }else{
     evector.vector.add(0.0);
    }
  }
  private void compute_previous_variability(){
    try{
     BufferedReader fin = new BufferedReader(new FileReader(pid+".variability"));
     String Line = fin.readLine(); //header
     while ((Line = fin.readLine()) != null){
       if(Line.split(",")[0].equals("AVERAGE")){
        //vector.vector.add(2.0);
        fin.close();
        break;
       }
       GregorianCalendar gc2 = DateUtil.createGC(Line.split(",")[0] + " 0:00:00");
       GregorianCalendar gc3 = DateUtil.createGC(DateUtil.makeTS(gc2));
       gc2.add(Calendar.HOUR, 48);
       gc3.add(Calendar.HOUR, 24);
       if(gc2.after(gc) && gc3.before(gc)){
        //System.out.println("day before " + DateUtil.makeTS(gc) + " : " + Line);
        //System.out.println("adding " + Line.split(",")[1]);
        evector.vector.add(Double.parseDouble(Line.split(",")[1]));//cpgv
        evector.vector.add(Double.parseDouble(Line.split(",")[2]));//mage
        evector.vector.add(Double.parseDouble(Line.split(",")[3]));//ef
        evector.vector.add(Double.parseDouble(Line.split(",")[4]));//dt
        evector.vector.add(Double.parseDouble(Line.split(",")[5]));//std
        fin.close();
        return;
       }
     }
     fin.close();
    }catch(IOException e){}
    //catch(FileNotFoundException e){}
    //System.out.println("adding 2.0");
    evector.vector.add(2.0);//cpgv
    evector.vector.add(150.0);//mage
    evector.vector.add(2.0);//ef
    evector.vector.add(1000.0);//dt
    evector.vector.add(50.0);//std
  }
  private void compute_average_variability(){
  
  }
  private void compute_recent_meal(){
    GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
    gc2.add(Calendar.MINUTE,-180);
    String query = "SELECT * FROM meal WHERE PID = " + pid + " AND TS >= " + DBUtil.createQueryTS(DateUtil.makeTS(gc2)) + " AND TS <= "
            + DBUtil.createQueryTS(DateUtil.makeTS(gc)) + " ORDER BY ts";
    //List<Reading> r60 = DBUtil.getCGMS(pid,gc2,gc,"meal where");
    double carbs = 0;
    double carbsop = 0;
    List<Reading> r0op = DBUtil.op_getMeals(gc2,gc);
    //System.out.println("range: " + DateUtil.makeTS(gc2) + " to " + DateUtil.makeTS(gc));
    //System.out.print("op = ");
    for(int i = 0; i < r0op.size(); ++i){
     carbsop += r0op.get(i).getValue();
     //System.out.println(DateUtil.makeTS(r0op.get(i).getT()) + " ");
    }
    evector.vector.add((double)(carbsop > 0? 1 : 0));
    
  }


  private void compute_recent_bolus(){
    GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
    gc2.add(Calendar.MINUTE,-180);
    String query = "SELECT * FROM bolus WHERE PID = " + pid + " AND TS >= " + DBUtil.createQueryTS(DateUtil.makeTS(gc2)) + " AND TS <= "
            + DBUtil.createQueryTS(DateUtil.makeTS(gc)) + " ORDER BY ts";
    //List<Reading> r60 = DBUtil.getCGMS(pid,gc2,gc,"meal where");
    double carbs = 0;
    //try{
    //ResultSet rs = DBUtil.QueryDB(query);
    List<BolusReading> r0 = DBUtil.op_getBoluses(gc2,gc);
    for(int i = 0; i < r0.size(); ++i){
     carbs += r0.get(i).getDose();
    }
    // while (rs.next()) {
    //     carbs += rs.getDouble("DOSE");
    // }
    //}catch(SQLException e){}
    evector.vector.add(carbs);
  }
  


private void compute_ind_physiological_model(List<Integer> indexes)
{
	try
	{
		String Line = physiological_model.readLine(); //timestamp
		while(!DateUtil.makeTS(gc).equals(Line))
		{
			if(gc.before(DateUtil.createGC(Line)))
			{
				System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + Line);
				System.exit(-1);
			}
			for( int i = 0; i < 13; i++)
			{
				read_physiological_model();
			}
			Line = physiological_model.readLine(); //timestamp
		}
		List<Double> v = read_physiological_model(); //state at 0 minutes

		for (int j = 1; j < 13; j++)
		{
			List<Double> v_pred = read_physiological_model(); //state at predicted minutes

			if(indexes.contains(j))
			{
				//System.out.println("Found index: " + j);
				for(int i = 0; i < 7; ++i)
				{
					evector.vector.add(v_pred.get(i));
				}
				for(int i = 0; i < 7; ++i)
				{
					evector.vector.add(v.get(i) - v_pred.get(i));
				}

			}
		}
    	}
	catch(IOException e)
	{
		System.out.println(e);
     		System.exit(-1);
    	}
  }




private List<Double> read_physiological_model() throws IOException
{
    	String Line = physiological_model.readLine(); //state prediction time
    	//System.out.println(Line);
    	List<Double> vec =  new ArrayList<Double>();
    	vec.add(parse_double(physiological_model.readLine(),135)); //glucose idx
    	vec.add(parse_double(physiological_model.readLine())); //glucose mass
    	vec.add(parse_double(physiological_model.readLine())); //carb gut 1
    	vec.add(parse_double(physiological_model.readLine())); //carb gut 2
    	vec.add(parse_double(physiological_model.readLine())); //insulin idx
    	vec.add(parse_double(physiological_model.readLine())); //insulin mass
    	vec.add(parse_double(physiological_model.readLine())); //insulin subskin idx
    	return vec;
    
}

private double parse_double(String num, double def)
{
   	Double ret = Double.parseDouble(num);
   	if(ret.isNaN())
	{
    		ret = def;
   	}
   	return ret;
}

private double parse_double(String num)
{
    	return parse_double(num,0);
}

public void compute_arima()
{
    	try
	{
		String Line = arima_models.readLine(); //timestamp
		String ts = Line.split(" ")[0] + " " + Line.split(" ")[1];

		while(!DateUtil.makeTS(gc).equals(ts))
		{
			if(gc.before(DateUtil.createGC(ts)))
			{
				 System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + ts);
				 System.exit(-1);
			}
				  
			Line = arima_models.readLine(); //timestamp
			ts = Line.split(" ")[0] + " " + Line.split(" ")[1];

		}
		String v[] = Line.split(" ");
		List<Double> values = new ArrayList<Double>();
		for(int i = 2; i < v.length; ++i)
		{
			values.add(Double.parseDouble(v[i]));
		}
		for(int i = 0; i < values.size(); ++i)
		{
			evector.vector.add(values.get(i));
		}
		   
    	}
	catch(IOException e)
	{
     		System.out.println(e);
     		System.exit(-1);
    	}
}



	public void compute_hours_asleep()
	{
		/*
		Find how long the patient has been asleep
		*/
		if(DBUtil.op_is_asleep(gc))
		{
     			int time_asleep = DBUtil.op_time_asleep(gc);
			double hours_asleep = time_asleep / 60.0;
			if(hours_asleep < 10.0)
			{
				evector.vector.add(hours_asleep);
			}
			else
			{
				// If the patient has been asleep for more than 10 hours
				// Assume they forgot to enter the time they woke up
				evector.vector.add(0.0);
			}
		}
		else
		{
			evector.vector.add(0.0);
		}
	}



	public void compute_nigel_dawn_p()
	{
		/*
		Nigel's dawn phenomenon feature
		Grows linearly starting at 4 hours of sleep, peaks at 6, and then linealry decreases back to 0
		at 8 hours of sleep
		*/
		if(DBUtil.op_is_asleep(gc))
		{
     			int time_asleep = DBUtil.op_time_asleep(gc);
     			if(time_asleep < 240)
			{//less than 4 hours
      				evector.vector.add(0.0);
     			}
			else if(time_asleep < 360)
			{//between 4 and 6 hours
      				//increasing slope
      				evector.vector.add(time_asleep - 240.0);
     			}
			else if(time_asleep < 480)
			{//between 6 and 8 hours
     				//decreasing slope
      				evector.vector.add(120 - time_asleep + 360.0);
     			}
			else
			{
      				evector.vector.add(0.0);
	     		}
		}
		else
		{
     			evector.vector.add(0.0);
    		}
	}


	public void compute_linear_dawn_p()
	{
		/*
		Linear growth dawn phenomenon
		Starts growing linearly at 4 hours of sleep
		Peaks at 8 hours of sleep
		drops back to 0 instantly after 8 hours of sleep	
		*/
		if(DBUtil.op_is_asleep(gc))
		{
     			int time_asleep = DBUtil.op_time_asleep(gc);
     			if(time_asleep < 240)
			{//less than 4 hours
      				evector.vector.add(0.0);
     			}
			else if(time_asleep < 480)
			{//between 4 and 8 hours
      				//increasing slope
      				evector.vector.add((time_asleep - 240.0)/2.0);
     			}
			else
			{
      				evector.vector.add(0.0);
	     		}
		}
		else
		{
     			evector.vector.add(0.0);
    		}
	}

	public void compute_quad_dawn_p()
	{
		/*
		Grows quadratically starting at 2 hours of sleep 
		peaks at 6, and then quadratically decreases
		back to 0 at 8 hours of sleep
		*/
		if(DBUtil.op_is_asleep(gc))
		{
			int time_asleep = DBUtil.op_time_asleep(gc);
			if(time_asleep < 120)
			{//less than 2 hours
      				evector.vector.add(0.0);
     			}
			else if(time_asleep < 360)
			{//between 2 and 6 hours
      				//values increasing quadratically
				double value = 0.0;
				value = (1.5 * time_asleep) - 150 -((time_asleep * time_asleep)/480);
      				evector.vector.add(value);
     			}
			else if(time_asleep < 480)
			{//between 6 and 8 hours
      				//values decreasing quadratically
      				double value = 0.0;
				value = (6.0 * time_asleep) - 960 - ((time_asleep * time_asleep)/120);
      				evector.vector.add(value);
     			}
			else
			{
      				evector.vector.add(0.0);
     			}
		}
		else
		{
     			evector.vector.add(0.0);
    		}
	}



  public void compute_avg_diff_dawn_p(int pred_time)
  {

    	if(DBUtil.op_is_asleep(gc) && !compute_basal_change())
	{
		int time_asleep = DBUtil.op_time_asleep(gc);
		int predict_time = time_asleep + pred_time;
		
		double[] p301_bgl_arr = {148.4230769231,147.8846153846,147.8846153846,148.5,147.6923076923,147.8461538462,148.9230769231,149.3076923077,148.3846153846,147.6153846154,147.0769230769,147.1153846154,147.3076923077,147.1923076923,146.2307692308,146.1153846154,145.6923076923,144.7307692308,143.5384615385,142.5384615385,140.8076923077,140.8846153846,140.7307692308,141.0384615385,141.2692307692,140.9230769231,140.7692307692,141.2692307692,141.7692307692,142.4615384615,143.7692307692,146.1538461538,148.4230769231,150,150.6538461538,151.5,152.4230769231,153.1923076923,154.4615384615,155.8076923077,157.4230769231,158.8076923077,160,160.9230769231,162.0384615385,163.3846153846,163.6923076923,164.3461538462,164.6153846154,164.1923076923,163.8076923077,163.6153846154,163.1153846154,162.8846153846,162.7692307692,162.6153846154,162.8076923077,162.7307692308,162.6153846154,162.5,162.7307692308,163.1153846154,163.3076923077,163.6538461538,163.4230769231,162.8461538462,161.7647058824,160.8235294118,159.6862745098,158.0784313725,156.9803921569,155.9215686275,154.8235294118,153.7254901961,152.862745098,152.6666666667,151.04,150.12,148.8571428571,147.8367346939,146.9795918367,146.2448979592,147.6326530612,148.1632653061,148.0833333333,146.3404255319,145.0212765957,144.2978723404,143.7021276596,142.7234042553,143.9459459459,134.6,134,132.8965517241,132.7586206897,132.6206896552};
		int p301_arr_length = 96;
		double[] p301_bgl_count_arr = {52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,52,51,51,51,51,51,51,51,51,51,51,50,50,49,49,49,49,49,49,48,47,47,47,47,47,37,30,30,29,29,29};

		double[] p304_bgl_arr = {143.2156862745,144.9019607843,144.9803921569,143.9215686275,143.7647058824,141.568627451,140.9411764706,140.7450980392,141.4901960784,141.9215686275,141.2941176471,141.3725490196,140.3529411765,140.431372549,140.7450980392,140.7058823529,141.2156862745,141.4901960784,142.1960784314,143.6470588235,142.9803921569,142.4705882353,141.9215686275,141.2156862745,140.5098039216,140.3137254902,140.5882352941,140.4705882353,140.1568627451,139.6862745098,139.4901960784,139.6078431373,139.4117647059,139.1764705882,139.6862745098,139.8823529412,140.0392156863,140.2352941176,140.3137254902,140.32,140.24,140.4,140.8,141.12,141.12,141.72,142.6,144.48,143.68,144.16,144.68,144.96,144.84,144.88,144.56,144.44,143.5918367347,144,145.4693877551,146.1632653061,146.5,148.7916666667,149,148.5531914894,149.6086956522,149.0434782609,148.2173913043,147.6956521739,147.7777777778,147.4222222222,147.6444444444,147.8222222222,148.5454545455,149.7674418605,150.3255813953,150.3255813953,150.0930232558,148.7142857143,152,152.8947368421,153.1578947368,152.2702702703,151.8378378378,151.0810810811,152.303030303,151.4545454545,152.3636363636,150.75,150.875,150.375,150.4137931034,149.5714285714,148.1481481481,148.5833333333,148.0833333333,146.9166666667,133.625,132.75,131.875,130.7692307692,128.5,127.5,116.8};
		int p304_arr_length = 103;
		double[] p304_bgl_count_arr = {51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,49,49,49,49,48,48,48,47,46,46,46,46,45,45,45,45,44,43,43,43,43,42,39,38,38,37,37,37,33,33,33,32,32,32,29,28,27,24,24,24,16,16,16,13,12,12,10};

		double[] p306_bgl_arr = {151.829787234,150.5106382979,148.7234042553,147.2340425532,146.170212766,145.7021276596,145.3617021277,145.7021276596,146.4680851064,146.5957446809,146.9361702128,147.3617021277,148.9787234043,150.4680851064,150.7234042553,151.3191489362,151.6595744681,152.2553191489,153.914893617,155.4468085106,157.2765957447,158.4680851064,158.9361702128,161.1489361702,163.5319148936,166.4680851064,168.4255319149,169.7446808511,171.1063829787,172.170212766,173.4468085106,174.2127659574,175.1914893617,175.5744680851,175.9574468085,176.2553191489,176.9361702128,177.914893617,178.7659574468,178.9361702128,179.0212765957,178.6382978723,177.7446808511,176.8510638298,175.6595744681,175.1063829787,175.1914893617,175.7872340426,176.2127659574,175.3617021277,175.4893617021,175.7021276596,175.2340425532,174.5957446809,174.2553191489,174.3404255319,174.2553191489,174.1276595745,173.6595744681,172.7659574468,171.7446808511,170.7234042553,170.0425531915,169.0638297872,170.8444444444,170.2666666667,173.2558139535,171.6097560976,172.65,174.6153846154,174.1578947368,173.6216216216,181.9310344828,193.0909090909,190.5454545455,193.619047619,193.619047619,191.8,189.2,190.4210526316,188.1052631579,185.7894736842,187.8888888889,185,182.1111111111,180,178.3333333333,176.8888888889,175.3333333333,173.4444444444,170.2352941176,174.5333333333,173.2,173.0666666667,166.2857142857,164.4285714286,160};
		int p306_arr_length = 97;
		double[] p306_bgl_count_arr = {47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,45,45,43,41,40,39,38,37,29,22,22,21,21,20,20,19,19,19,18,18,18,18,18,18,18,18,17,15,15,15,14,14,10};

		double[] p310_bgl_arr = {149.3928571429,149.0357142857,147.2142857143,144.5,143.3928571429,142.6428571429,141.9285714286,140.75,140.6071428571,139.5357142857,138.1071428571,137.3571428571,136.1071428571,138.3214285714,138.0714285714,137.4285714286,138.0357142857,138.75,139.3214285714,139.9285714286,139.8928571429,139.2142857143,138.6428571429,137.7857142857,136.75,136.0714285714,135.6428571429,135.8571428571,135.5714285714,134.6428571429,133.9642857143,132.75,132.4642857143,132.6785714286,133.4285714286,134.4285714286,135.5,136,136.4642857143,136.8571428571,138.2142857143,139.1071428571,140.0714285714,140.75,141.4642857143,142.3214285714,143.8928571429,144.8214285714,145.2142857143,145.2857142857,145.3928571429,146.0714285714,146.8571428571,147.8928571429,148.8928571429,149.4642857143,149.5714285714,149.9642857143,150.2142857143,150.5714285714,151,151.3571428571,152.0714285714,152.9642857143,153.8928571429,154.3214285714,155.1071428571,156.7636363636,157.0909090909,157.2363636364,157.7818181818,158.7272727273,159.8490566038,160.5384615385,161,162.6666666667,163.6078431373,164.9019607843,169.4782608696,171.9545454545,172.6818181818,174.7441860465,175.9534883721,177.1627906977,181.75,178.3783783784,178.9189189189,182.8,183.4857142857,182.8,183.8666666667,188.9285714286,188,186.2962962963,187.4074074074,188.4444444444,184.9166666667,164.6666666667,162.4444444444,162.3529411765,158.5333333333,156.5333333333,153.6,151.6,148.6};
		int p310_arr_length = 105;
		double[] p310_bgl_count_arr = {56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,56,55,55,55,55,55,53,52,52,51,51,51,46,44,44,43,43,43,40,37,37,35,35,35,30,28,28,27,27,27,24,18,18,17,15,15,10,10,10};

		double[] p312_bgl_arr = {154.4090909091,152.5909090909,151.0909090909,150,150.2727272727,148.8636363636,148,147.4545454545,147.5,147.3181818182,147.3181818182,147.6818181818,147.4090909091,147.4545454545,147.8636363636,148.1818181818,148.4090909091,148.3636363636,148.6818181818,148.8636363636,149.5,149.5909090909,149.3181818182,149.0909090909,149.1363636364,149.5909090909,150.3636363636,151.6818181818,152.7727272727,154.2727272727,151.6279069767,152.9302325581,154.4186046512,155.9534883721,157.8604651163,159.3953488372,160.6046511628,161.4418604651,162.8837209302,164.0930232558,165.7209302326,168,171.7674418605,174.0465116279,177.5813953488,179.8604651163,182.2325581395,184.4186046512,186.5581395349,188.1860465116,189.9069767442,191.6744186047,194.3255813953,195.5813953488,197.1162790698,198.511627907,199.3023255814,199.3953488372,200.0465116279,201.1627906977,202.1395348837,203.1162790698,204.6046511628,205.6279069767,205.488372093,204.976744186,205.5348837209,206.3720930233,207.3953488372,210,208.7804878049,208.6829268293,210.2564102564,209.2820512821,208.7692307692,210.2702702703,209.3333333333,208,206.5714285714,205.6470588235,204.5294117647,194.7,196,195.5,194.625,192.75,190.625,187.8666666667,186,184.6666666667,182.8,188,186.7692307692,184.1538461538,181.5384615385,178.3076923077,177.0909090909};
		int p312_arr_length = 97;
		double[] p312_bgl_count_arr = {44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,42,41,41,39,39,39,37,36,36,35,34,34,20,16,16,16,16,16,15,15,15,15,13,13,13,13,13,11};

		double[] p313_bgl_arr = {179.3333333333,182.5,183.5,184.25,183.875,183.75,183.25,182.875,183.375,183.625,183.5,183.0416666667,181.8333333333,180.875,179.1666666667,177.6666666667,176.1666666667,175.0416666667,173.9166666667,172.75,172.0833333333,171.25,170.5416666667,169.75,168.6666666667,167.5,165.9166666667,163.9166666667,162.375,161.3333333333,160.625,160.125,159.375,158.875,158.5833333333,158.9583333333,159.625,159.8333333333,159.6666666667,159.5,159.2916666667,159.6666666667,161.3617021277,161.6170212766,161.829787234,162.2553191489,162.6808510638,163.0638297872,164.4255319149,165.0638297872,165.1489361702,164.8510638298,164.9787234043,165.6595744681,166.0869565217,165.5652173913,165.2608695652,164.9130434783,164.9565217391,165.6956521739,165.6363636364,166.1363636364,167.1363636364,167.3953488372,168.3255813953,169.023255814,169.3953488372,169.4418604651,169.4418604651,166.8780487805,165.756097561,165.0243902439,164.5263157895,163.8378378378,164.4324324324,165.3333333333,158.3529411765,157.0588235294,154.6451612903,156.5517241379,156.6896551724,156.1666666667,161.9090909091,162.5454545455,150.3529411765,155.625,157.75,163.8};
		int p313_arr_length = 88;
		double[] p313_bgl_count_arr = {48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,47,47,47,47,47,47,47,47,47,47,47,47,46,46,46,46,46,46,44,44,44,43,43,43,43,43,43,41,41,41,38,37,37,36,34,34,31,29,29,24,22,22,17,16,16,10};

		double[] p316_bgl_arr = {162.9473684211,163.3684210526,163.3684210526,163.3684210526,163.5789473684,163.2631578947,163.5789473684,163.6842105263,163.5789473684,163.1578947368,163.1578947368,163.4736842105,164.1052631579,165.2631578947,165.6842105263,166.2105263158,167.7894736842,169.3684210526,170.5263157895,171.2631578947,171.6842105263,172,172.1052631579,171.8947368421,172.4210526316,172.3157894737,172.4210526316,172,171.6842105263,171.6842105263,171.2631578947,171.5789473684,171.1578947368,170.6315789474,169.3684210526,168.9473684211,168.7368421053,168.5263157895,168.1052631579,167.2631578947,166.4210526316,166.2105263158,166.8421052632,166,166.6315789474,168.4444444444,168.8888888889,167.7777777778,172.2352941176,170.8235294118,171.0588235294,170,170,170,171.125,170.2857142857,170.4285714286,169.8571428571,170,169.7142857143,164.7692307692,164.7692307692,163.6923076923,163.3846153846,162.6153846154,160.6666666667,155.8,152.6,151.6,150.2,149.8,149.2};
		int p316_arr_length = 72;
		double[] p316_bgl_count_arr = {19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,18,18,18,17,17,17,17,17,17,16,14,14,14,14,14,13,13,13,13,13,12,10,10,10,10,10,10};

		int first_index = time_asleep / 5;
		int second_index = predict_time / 5;

		double difference;

		

		double avg_pred_bgl=0;
		double avg_t0_bgl=0;
		double count=0;
		int index_diff = 0;
		int index_error = 0;

		
		
		
		if(pid == 304)
		{
			if(first_index < p304_arr_length)
			{
				if(second_index < p304_arr_length)
				{
					avg_pred_bgl = p304_bgl_arr[second_index];
					count = p304_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p304_bgl_arr[p304_arr_length - 1];
					count = p304_bgl_count_arr[p304_arr_length - 1];
					index_diff = p304_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p304_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 301)
		{
			if(first_index < p301_arr_length)
			{
				if(second_index < p301_arr_length)
				{
					avg_pred_bgl = p301_bgl_arr[second_index];
					count = p301_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p301_bgl_arr[p301_arr_length - 1];
					count = p301_bgl_count_arr[p301_arr_length - 1];
					index_diff = p301_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p301_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 306)
		{
			if(first_index < p306_arr_length)
			{
				if(second_index < p306_arr_length)
				{
					avg_pred_bgl = p306_bgl_arr[second_index];
					count = p306_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p306_bgl_arr[p306_arr_length - 1];
					count = p306_bgl_count_arr[p306_arr_length - 1];
					index_diff = p306_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p306_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 310)
		{
			if(first_index < p310_arr_length)
			{
				if(second_index < p310_arr_length)
				{
					avg_pred_bgl = p310_bgl_arr[second_index];
					count = p310_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p310_bgl_arr[p310_arr_length - 1];
					count = p310_bgl_count_arr[p310_arr_length - 1];
					index_diff = p310_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p310_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 312)
		{
			if(first_index < p312_arr_length)
			{
				if(second_index < p312_arr_length)
				{
					avg_pred_bgl = p312_bgl_arr[second_index];
					count = p312_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p312_bgl_arr[p312_arr_length - 1];
					count = p312_bgl_count_arr[p312_arr_length - 1];
					index_diff = p312_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p312_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 313)
		{
			if(first_index < p313_arr_length)
			{
				if(second_index < p313_arr_length)
				{
					avg_pred_bgl = p313_bgl_arr[second_index];
					count = p313_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p313_bgl_arr[p313_arr_length - 1];
					count = p313_bgl_count_arr[p313_arr_length - 1];
					index_diff = p313_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p313_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else if(pid == 316)
		{
			if(first_index < p316_arr_length)
			{
				if(second_index < p316_arr_length)
				{
					avg_pred_bgl = p316_bgl_arr[second_index];
					count = p316_bgl_count_arr[second_index];
					index_diff = second_index - first_index;
				}
				else
				{
					
					avg_pred_bgl = p316_bgl_arr[p316_arr_length - 1];
					count = p316_bgl_count_arr[p316_arr_length - 1];
					index_diff = p316_arr_length - 1 - first_index;
				}
				avg_t0_bgl = p316_bgl_arr[first_index];
			}
			else
			{
				index_error = 1;
			}
		}
		else
		{
			System.out.println("Error pid not found: ");
			System.out.println(pid);
			index_error = 1;
		}


		if(index_error == 1)
		{
			difference = 0.0;
		}
		else
		{

			int actual_pred_time = index_diff * 5;

			
			//find actual bgl to remove it from average
			double actual_bgl;
			GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
   			gc2.add(Calendar.MINUTE,actual_pred_time);


   			List<Reading> r30 = DBUtil.op_getCGMS(gc2,gc2);
   			if(r30.size() > 0)
			{	
    				actual_bgl = r30.get(0).getValue();
   			}
			else
			{
    				while(r30.size() == 0)
				{
	     				gc2.add(Calendar.MINUTE,-5);
	     				//r30 = DBUtil.getCGMS(pid,gc2,gc2,"cgms where");
	     				r30 = DBUtil.op_getCGMS(gc2,gc2);
	    			}	
    				actual_bgl = r30.get(0).getValue();
			}
			//end find actual bgl

			//remove actual prediction bgl from average
			
			avg_pred_bgl = ((avg_pred_bgl * count) - actual_bgl)/(count - 1.0);

			difference = avg_pred_bgl - avg_t0_bgl;

		}
		evector.vector.add(difference);
	}
	else
	{
     		evector.vector.add(0.0);
    	}
  }


  
  
  public void compute_awake()
  {
	if(DBUtil.op_is_asleep(gc))
	{
		evector.vector.add(0.0);
	}
	else
	{
     		evector.vector.add(1.0);
    	}
  }

  
  private boolean compute_basal_change()
	{
		if(DBUtil.op_is_asleep(gc))
		{
    			int bin_size = 60;
    			int length = 60;
			int time_asleep = DBUtil.op_time_asleep(gc);
			int time_awake = 480 - time_asleep;
			boolean changes = false;
			double rate = -1.0;

			GregorianCalendar fall_asleep = DateUtil.copyGC(gc);
			fall_asleep.add(Calendar.MINUTE, -1 * time_asleep);
        		GregorianCalendar wake_up = DateUtil.copyGC(gc);
			wake_up.add(Calendar.MINUTE, time_awake);
			GregorianCalendar cur = DateUtil.copyGC(gc);
			//System.out.println("Cur: " + DateUtil.makeTS(cur) + " fall asleep: " + DateUtil.makeTS(fall_asleep) + " wake up: " + DateUtil.makeTS(wake_up));
			
    			
        		List<BasalReading> basal = DBUtil.op_getBasals(null,null);
        		double ret = 0;

            		for (BasalReading b : basal) 
			{
               
			               //System.out.println(DateUtil.makeTS(b.getStart())+"  "+ DateUtil.makeTS(b.getEnd()));


				if (!b.getStart().after(fall_asleep) && b.getEnd().after(fall_asleep)) 
				{
					//System.out.println("Found basal when they fell asleep");
					//the basal rate when they fell asleep
					if(b.getEnd().after(wake_up))
					{
						//System.out.println("Rate does not change");
						changes = false;
						break;
					}
					else
					{
						//System.out.println("End point is not after they wake up");
						if(rate == -1.0)
						{
							//System.out.println("Set rate to " + b.getValue());
							//get the rate for when they fell asleep
							rate = b.getValue();
						}
					}
						
				}
				if (b.getStart().after(fall_asleep) && !b.getStart().after(wake_up))
				{
					//find a new rate that changes after they fall asleep and before they wake up
					//System.out.println("Previous rate: " + rate + " Current Rate " + b.getValue());
					if(rate < b.getValue())
					{
						//basal rate rises
						changes = true;
						//System.out.println("Rate Changes from " + rate + " to " + b.getValue());
						break;
					}
					else
					{
						//basal rate lowers, change rate to reflect this
						rate = b.getValue();
					}
				}

                			
            		}
        			
     			return changes;	
		}
		else
		{
			//System.out.println("Not Asleep");
			return false;
		}

  	}



  	
  



/*
***************************************************************************************************************************************************
IMPORTANT, PLEASE READ

All following feature vector functions are no longer in use. Some may have notes explaining why they are no longer used. Others may not.
Do not make any assumptions about these functions, there is little to no documentation for them, and they were written over several years 
by multiple people. There is not even any guarantee that these functions are complete or work in the intended way. I have discovered that
one function does not work, or at least not in the way I assumed it was intended to. I have made a note for that function, but I have not 
had time to check the others. I also have not had reason to do so.

If you end up removing an old feature function, please move it below this section so the distinction is clear, and clearly document why
the function/feature was removed. Make a note of whether the function was removed because the code itself did not create the intended 
feature, or if the feature was not helpful for prediction. Please provide clear documentation of what the intended feature was.

If there are no comments for a function, assume nothing is known about it.

Thanks,
Kevin Plis
September 9th 2014
****************************************************************************************************************************************************
*/


private void compute_meal(){
    int bin_size = 10;
    int length = 60;
    for(int i = 0; i + bin_size <= length; i += bin_size){
        int start = i + bin_size;
        int end = i;
        GregorianCalendar start_t = DateUtil.copyGC(gc);
        GregorianCalendar end_t = DateUtil.copyGC(gc);
        start_t.add(Calendar.MINUTE, -1 * start);
        end_t.add(Calendar.MINUTE, -1 * end - 1);
        List<Reading> meal = DBUtil.op_getMeals(start_t,end_t);
        double ret = 0;
//        System.out.println("Computing insulin between: " + DateUtil.makeTS(start) + " and " + DateUtil.makeTS(end));
        for (Reading m : meal) {
          ret += m.getValue();
        }
        evector.vector.add(ret);
     }
  }

private void compute_basal_Rate()
	{
    		int bin_size = 60;
    		int length = 60;
    		for(int i = 0; i + bin_size <= length; i += bin_size)
		{
			System.out.println("i: " + i + " binsize: " + bin_size + " length: " + length);
        		int start_ts = i + bin_size;
        		int end_ts = i;
        		GregorianCalendar start = DateUtil.copyGC(gc);
        		GregorianCalendar end = DateUtil.copyGC(gc);
        		start.add(Calendar.MINUTE, -1 * start_ts);
        		end.add(Calendar.MINUTE, -1 * end_ts - 1);
        		List<BasalReading> basal = DBUtil.op_getBasals(null,null);
        		double ret = 0;
        		GregorianCalendar cur = DateUtil.copyGC(start);
        System.out.println("Computing insulin between: " + DateUtil.makeTS(start) + " and " + DateUtil.makeTS(end));
//        while (cur.before(end)) {
//            System.out.println(DateUtil.makeTS(cur));
            		for (BasalReading b : basal) 
			{
                System.out.println(DateUtil.makeTS(b.getStart()) + "        " + DateUtil.makeTS(b.getEnd()) + "          " + DateUtil.makeTS(cur));
//                System.out.println(b.getStart().compareTo(cur)+"  "+b.getEnd().compareTo(cur) );

// I don't think this check is working, the function keeps updating cur, causing it to compute the insulin for the entire basal insulin after the
// current time, even if that is several weeks
                		if (!b.getStart().after(cur) && b.getEnd().after(cur)) 
				{
                    			double hrs = -1;
                    			if (!b.getEnd().after(end)) 
					{
                        			hrs = DateUtil.getMinuteDiff(cur, end) / 60.0;
                        			cur = DateUtil.copyGC(end);
                    			} 
					else 
					{
                        			hrs = DateUtil.getMinuteDiff(cur, b.getEnd()) / 60.0;
                        			cur = DateUtil.copyGC(b.getEnd());
                    			}
                    System.out.println("Adding insulin from basal readings: " + (b.getValue() * hrs) + "   (" + b.getValue() + " * " + hrs + ")");
                    			ret += (b.getValue() * hrs);
                		}
            		}
//        }
        System.out.println("returning value: " + ret);
        		evector.vector.add(ret);
     		}
  	}



  private void compute_basal_area(){
    int bin_size = 60;
    int length = 60;
    for(int i = 0; i + bin_size <= length; i += bin_size){
        int start_ts = i + bin_size;
        int end_ts = i;
        GregorianCalendar start = DateUtil.copyGC(gc);
        GregorianCalendar end = DateUtil.copyGC(gc);
        start.add(Calendar.MINUTE, -1 * start_ts);
        end.add(Calendar.MINUTE, -1 * end_ts - 1);
        List<BasalReading> basal = DBUtil.op_getBasals(null,null);
        double ret = 0;
        GregorianCalendar cur = DateUtil.copyGC(start);
        List<Double> vals = new ArrayList<Double>();
        List<Double> times = new ArrayList<Double>();
//        System.out.println("Computing insulin between: " + DateUtil.makeTS(start) + " and " + DateUtil.makeTS(end));
//        while (cur.compareTo(end) < 0) {
//            System.out.println(DateUtil.makeTS(cur));
            for (BasalReading b : basal) {
//                System.out.println(DateUtil.makeTS(b.getStart()) + "        " + DateUtil.makeTS(b.getEnd()));
//                System.out.println(b.getStart().compareTo(cur)+"  "+b.getEnd().compareTo(cur) );
                if (b.getStart().compareTo(cur) <= 0 && b.getEnd().compareTo(cur) > 0) {
                    double hrs = -1;
                    if (b.getEnd().compareTo(end) >= 0) {
                        hrs = DateUtil.getMinuteDiff(cur, end) / 60.0;
                        cur = DateUtil.copyGC(end);
                    } else {
                        hrs = DateUtil.getMinuteDiff(cur, b.getEnd()) / 60.0;
                        cur = DateUtil.copyGC(b.getEnd());
                    }
                    vals.add(b.getValue());
                    times.add(hrs);
//                    System.out.println("Adding insulin from basal readings: " + (b.getValue() * hrs) + "   (" + b.getValue() + " * " + hrs + ")");
                }
            }
//        }
        double avg = 0;
        for(Double d : vals){
            avg += d;
        }
        avg = avg/vals.size();
        for(int j = 0; j < vals.size(); j++){
            ret += (Math.abs(vals.get(j) - avg) * times.get(j));
        }
//        System.out.println("returning value: " + ret);
        evector.vector.add(ret);
     }
  }



private void compute_bolus()
	{
    		int bin_size = 10;
    		int length = 60;
    		for(int i = 0; i + bin_size <= length; i += bin_size)
		{
        		int start = i + bin_size;
        		int end = i;
        		GregorianCalendar start_t = DateUtil.copyGC(gc);
        		GregorianCalendar end_t = DateUtil.copyGC(gc);
        		start_t.add(Calendar.MINUTE, -1 * start);
        		end_t.add(Calendar.MINUTE, -1 * end - 1);
        		List<BolusReading> bolus = DBUtil.op_getBoluses(start_t,end_t);
        		double ret = 0;
		//        System.out.println("Computing insulin between: " + DateUtil.makeTS(start) + " and " + DateUtil.makeTS(end));
        		for (BolusReading b : bolus) 
			{
            			if (b.getDuration() > 0) 
				{
                			double bolus_rate = b.getDose() / b.getDuration();
                			double duration = b.getDuration();
                			GregorianCalendar bolus_end = DateUtil.copyGC(b.getT());
                			bolus_end.add(Calendar.MINUTE, (int) b.getDuration());
                			if ((b.getT().compareTo(start_t) >= 0 && b.getT().compareTo(end_t) < 0)) 
					{
                    				if (bolus_end.compareTo(end_t) >= 0) 
						{
                        				duration = DateUtil.getMinuteDiff(b.getT(), end_t);
                    				}
//                    				System.out.println("Adding square bolus amount: " + (bolus_rate * duration) + "   (" + b.getDose() + " / " + b.getDuration() + " * " + duration + ")");
                    				ret += (bolus_rate * duration);
                			} 
					else if (bolus_end.compareTo(start_t) >= 0 && b.getT().compareTo(start_t) <= 0) 
					{
                    				if (bolus_end.compareTo(end_t) >= 0) 
						{
                        				duration = DateUtil.getMinuteDiff(start_t, end_t);
                    				} 
						else 
						{
                        				duration = DateUtil.getMinuteDiff(start_t, bolus_end);
                    				}
                    				ret += (bolus_rate * duration);
//                    System.out.println("Adding square bolus amount: " + (bolus_rate * duration) + "   (" + b.getDose() + " / " + b.getDuration() + " * " + duration + ")");
                			}
            			} 
				else 
				{
                			if (b.getT().compareTo(start_t) >= 0 && b.getT().compareTo(end_t) < 0) 
					{
                    				ret += b.getDose();
//                    				System.out.println("Adding bolus value: " + b.getDose());
                			}
            			}
        		}
//        		System.out.println("returning value: " + ret);
        		evector.vector.add(ret);
     		}
  	}


public void compute_time()
  {
 
    evector.vector.add((double)gc.get(Calendar.MINUTE)+gc.get(Calendar.HOUR_OF_DAY)*60);
  }

  private void compute_moving_average(){
    int []k = {3,6,9,12};
    double top, bottom;
    double lambda = 0.9;
    GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
    gc2.add(Calendar.MINUTE,-60);
    List<Reading> r60 = DBUtil.op_getCGMS(gc2,gc);
    for(int i = 0; i < k.length; ++i){
      top = bottom = 0;
      for(int n = k[i]; n >= 0; --n){
       double y;
       if(n >= r60.size()){
        y = evector.vector.get(2);
       }else{
        y = r60.get(r60.size()-1-n).getValue();
       }
       top += Math.pow(lambda,n)*y;
       bottom += Math.pow(lambda,n);
      }
      evector.vector.add(top/bottom);
    }
  }
  private void compute_rate_of_change(){
    int []k = {3,6,9,12};
    double top, bottom;
    double lambda = 0.25;
    GregorianCalendar gc2 = DateUtil.createGC(DateUtil.makeTS(gc));
    gc2.add(Calendar.MINUTE,-65);
    List<Reading> r60 = DBUtil.op_getCGMS(gc2,gc);
    for(int i = 0; i < k.length; ++i){
      top = bottom = 0;
      for(int n = k[i]-1; n >= 0; --n){
       double yti, yti1;
       if(n >= r60.size()){
        yti = evector.vector.get(2);
       }else{
        yti = r60.get(r60.size()-1-n).getValue();
       }
       if(n-1>= r60.size() || n == 0){
        yti1 = evector.vector.get(2);
       }else{
        yti1 = r60.get(r60.size()-n).getValue();
       }
       top += Math.pow(lambda,n)*(yti-yti1);
       bottom += Math.pow(lambda,n);
      }
      evector.vector.add(top/bottom);
    }
  }
  private void compute_matts_arima(){
    try{
		   String Line = arima_models.readLine(); //timestamp
		   String ts = Line.split(" ")[0] + " " + Line.split(" ")[1];
		   //System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + ts);
		   while(!DateUtil.makeTS(gc).equals(ts)){
				  if(gc.before(DateUtil.createGC(ts))){
				   System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + ts);
				   System.exit(-1);
				  }
				  
				  Line = arima_models.readLine(); //timestamp
				  ts = Line.split(" ")[0] + " " + Line.split(" ")[1];
      //System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + ts);
		   }
		   String v[] = Line.split(" ");
		   List<Double> values = new ArrayList<Double>();
		   for(int i = 2; i < v.length; ++i){
		    values.add(Double.parseDouble(v[i]));
		   }
	    evector.vector.add(values.get((LOOKAHEAD/5)-1));
		   
    }catch(IOException e){
     System.out.println(e);
     System.exit(-1);
    }
  }

/*
This function is no longer needed. compute_individual_physiological_model and handle this situation

The purpose was for it to add the physiological information for all 5 minute increments BEFORE the prediction time.
So if you were predicting 40 minutes from now, it would find the information for 5, 10, 15, 20, 25, 30, 35, and 40 minutes
*/
private void compute_before_physiological_model()
{
	try
	{
		int index = LOOKAHEAD / 5;
		String Line = physiological_model.readLine(); //timestamp
		while(!DateUtil.makeTS(gc).equals(Line))
		{
			if(gc.before(DateUtil.createGC(Line)))
			{
				System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + Line);
				System.exit(-1);
			}
			for( int i = 0; i < 13; i++)
			{
				read_physiological_model();
			}
			Line = physiological_model.readLine(); //timestamp
		}
		List<Double> v = read_physiological_model(); //state at 0 minutes

		for (int j = 1; j <= index; j++)
		{
			List<Double> v_pred = read_physiological_model(); //state at predicted minutes
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v_pred.get(i));
			}
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v.get(i) - v_pred.get(i));
			}
		}

		//Keep reading through other predictions for time stamp so as to not stop halfway through an entry
		for (int j = index+1; j < 13; j++)
		{
			read_physiological_model();
		}

    	}
	catch(IOException e)
	{
		System.out.println(e);
     		System.exit(-1);
    	}


}


/*
This function is no longer needed. compute_individual_physiological_model and handle this situation

The purpose was for it to add the physiological information for all 5 minute increments AFTER the prediction time.
So if you were predicting 40 minutes from now, it would find the information for 40, 45, 50, and 55 minutes
*/
private void compute_after_physiological_model()
{
	try
	{
		int index = LOOKAHEAD / 5;
		String Line = physiological_model.readLine(); //timestamp
		while(!DateUtil.makeTS(gc).equals(Line))
		{
			if(gc.before(DateUtil.createGC(Line)))
			{
				System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + Line);
				System.exit(-1);
			}
			for( int i = 0; i < 13; i++)
			{
				read_physiological_model();
			}
			Line = physiological_model.readLine(); //timestamp
		}
		List<Double> v = read_physiological_model(); //state at 0 minutes

		for (int j = 1; j < index; j++)
		{
			read_physiological_model();
		}


		for (int j = index; j < 13; j++)
		{
			
			List<Double> v_pred = read_physiological_model(); //state at predicted minutes
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v_pred.get(i));
			}
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v.get(i) - v_pred.get(i));
			}
		}

    	}
	catch(IOException e)
	{
		System.out.println(e);
     		System.exit(-1);
    	}


}


/*
This function is no longer needed. compute_individual_physiological_model and handle this situation

The purpose was for it to add the physiological information for 30 and 60 minutes after t0
*/
private void compute_physiological_model()
{
	/*
	This function reads in the physiological model information for the time point
	*/
	try
	{
		String Line = physiological_model.readLine(); //timestamp

		while(!DateUtil.makeTS(gc).equals(Line))
		{
			if(gc.before(DateUtil.createGC(Line)))
			{
				// Have passed the time we are looking for in the data file
				// We assume this means there is no physiological information for the time point
				// Physiological information must be in order in the file
				System.out.println("looking for " + DateUtil.makeTS(gc) + " found " + Line);
				System.exit(-1);
			}
			for( int i = 0; i < 13; i++)
			{
				// Read through physiological model to get to next timestamp
				read_physiological_model();
			}
			Line = physiological_model.readLine(); //timestamp
		}
		List<Double> v = read_physiological_model(); //state at 0 minutes

		for( int j = 1; j<13; j++)
		{
			List<Double> v_pred = read_physiological_model(); //state at predicted minutes
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v_pred.get(i));
			}
			for(int i = 0; i < 7; ++i)
			{
				evector.vector.add(v.get(i) - v_pred.get(i));
			}
		}
    	}
	catch(IOException e)
	{
		System.out.println(e);
     		System.exit(-1);
    	}
  }

//dawn phenomenon feature, using the average bgl for that patient after that amount of time of sleep
public void compute_avg_dawn_p(int pred_time)
  {

    	if(DBUtil.op_is_asleep(gc))
	{
		int time_asleep = DBUtil.op_time_asleep(gc);
		int predict_time = time_asleep + pred_time;
		double[] p301_bgl_arr = {148.4230769231,147.8846153846,147.8846153846,148.5,147.6923076923,147.8461538462,148.9230769231,149.3076923077,148.3846153846,147.6153846154,147.0769230769,147.1153846154,147.3076923077,147.1923076923,146.2307692308,146.1153846154,145.6923076923,144.7307692308,143.5384615385,142.5384615385,140.8076923077,140.8846153846,140.7307692308,141.0384615385,141.2692307692,140.9230769231,140.7692307692,141.2692307692,141.7692307692,142.4615384615,143.7692307692,146.1538461538,148.4230769231,150,150.6538461538,151.5,152.4230769231,153.1923076923,154.4615384615,155.8076923077,157.4230769231,158.8076923077,160,160.9230769231,162.0384615385,163.3846153846,163.6923076923,164.3461538462,164.6153846154,164.1923076923,163.8076923077,163.6153846154,163.1153846154,162.8846153846,162.7692307692,162.6153846154,162.8076923077,162.7307692308,162.6153846154,162.5,162.7307692308,163.1153846154,163.3076923077,163.6538461538,163.4230769231,162.8461538462,161.7647058824,160.8235294118,159.6862745098,158.0784313725,156.9803921569,155.9215686275,154.8235294118,153.7254901961,152.862745098,152.6666666667,151.04,150.12,148.8571428571,147.8367346939,146.9795918367,146.2448979592,147.6326530612,148.1632653061,148.0833333333,146.3404255319,145.0212765957,144.2978723404,143.7021276596,142.7234042553,143.9459459459,134.6,134,132.8965517241,132.7586206897,132.6206896552};
		int p301_arr_length = 96;
		double[] p304_bgl_arr = {143.2156862745,144.9019607843,144.9803921569,143.9215686275,143.7647058824,141.568627451,140.9411764706,140.7450980392,141.4901960784,141.9215686275,141.2941176471,141.3725490196,140.3529411765,140.431372549,140.7450980392,140.7058823529,141.2156862745,141.4901960784,142.1960784314,143.6470588235,142.9803921569,142.4705882353,141.9215686275,141.2156862745,140.5098039216,140.3137254902,140.5882352941,140.4705882353,140.1568627451,139.6862745098,139.4901960784,139.6078431373,139.4117647059,139.1764705882,139.6862745098,139.8823529412,140.0392156863,140.2352941176,140.3137254902,140.32,140.24,140.4,140.8,141.12,141.12,141.72,142.6,144.48,143.68,144.16,144.68,144.96,144.84,144.88,144.56,144.44,143.5918367347,144,145.4693877551,146.1632653061,146.5,148.7916666667,149,148.5531914894,149.6086956522,149.0434782609,148.2173913043,147.6956521739,147.7777777778,147.4222222222,147.6444444444,147.8222222222,148.5454545455,149.7674418605,150.3255813953,150.3255813953,150.0930232558,148.7142857143,152,152.8947368421,153.1578947368,152.2702702703,151.8378378378,151.0810810811,152.303030303,151.4545454545,152.3636363636,150.75,150.875,150.375,150.4137931034,149.5714285714,148.1481481481,148.5833333333,148.0833333333,146.9166666667,133.625,132.75,131.875,130.7692307692,128.5,127.5,116.8};
		int p304_arr_length = 103;
		double[] p306_bgl_arr = {151.829787234,150.5106382979,148.7234042553,147.2340425532,146.170212766,145.7021276596,145.3617021277,145.7021276596,146.4680851064,146.5957446809,146.9361702128,147.3617021277,148.9787234043,150.4680851064,150.7234042553,151.3191489362,151.6595744681,152.2553191489,153.914893617,155.4468085106,157.2765957447,158.4680851064,158.9361702128,161.1489361702,163.5319148936,166.4680851064,168.4255319149,169.7446808511,171.1063829787,172.170212766,173.4468085106,174.2127659574,175.1914893617,175.5744680851,175.9574468085,176.2553191489,176.9361702128,177.914893617,178.7659574468,178.9361702128,179.0212765957,178.6382978723,177.7446808511,176.8510638298,175.6595744681,175.1063829787,175.1914893617,175.7872340426,176.2127659574,175.3617021277,175.4893617021,175.7021276596,175.2340425532,174.5957446809,174.2553191489,174.3404255319,174.2553191489,174.1276595745,173.6595744681,172.7659574468,171.7446808511,170.7234042553,170.0425531915,169.0638297872,170.8444444444,170.2666666667,173.2558139535,171.6097560976,172.65,174.6153846154,174.1578947368,173.6216216216,181.9310344828,193.0909090909,190.5454545455,193.619047619,193.619047619,191.8,189.2,190.4210526316,188.1052631579,185.7894736842,187.8888888889,185,182.1111111111,180,178.3333333333,176.8888888889,175.3333333333,173.4444444444,170.2352941176,174.5333333333,173.2,173.0666666667,166.2857142857,164.4285714286,160};
		int p306_arr_length = 97;
		double[] p310_bgl_arr = {149.3928571429,149.0357142857,147.2142857143,144.5,143.3928571429,142.6428571429,141.9285714286,140.75,140.6071428571,139.5357142857,138.1071428571,137.3571428571,136.1071428571,138.3214285714,138.0714285714,137.4285714286,138.0357142857,138.75,139.3214285714,139.9285714286,139.8928571429,139.2142857143,138.6428571429,137.7857142857,136.75,136.0714285714,135.6428571429,135.8571428571,135.5714285714,134.6428571429,133.9642857143,132.75,132.4642857143,132.6785714286,133.4285714286,134.4285714286,135.5,136,136.4642857143,136.8571428571,138.2142857143,139.1071428571,140.0714285714,140.75,141.4642857143,142.3214285714,143.8928571429,144.8214285714,145.2142857143,145.2857142857,145.3928571429,146.0714285714,146.8571428571,147.8928571429,148.8928571429,149.4642857143,149.5714285714,149.9642857143,150.2142857143,150.5714285714,151,151.3571428571,152.0714285714,152.9642857143,153.8928571429,154.3214285714,155.1071428571,156.7636363636,157.0909090909,157.2363636364,157.7818181818,158.7272727273,159.8490566038,160.5384615385,161,162.6666666667,163.6078431373,164.9019607843,169.4782608696,171.9545454545,172.6818181818,174.7441860465,175.9534883721,177.1627906977,181.75,178.3783783784,178.9189189189,182.8,183.4857142857,182.8,183.8666666667,188.9285714286,188,186.2962962963,187.4074074074,188.4444444444,184.9166666667,164.6666666667,162.4444444444,162.3529411765,158.5333333333,156.5333333333,153.6,151.6,148.6};
		int p310_arr_length = 105;
		double[] p312_bgl_arr = {154.4090909091,152.5909090909,151.0909090909,150,150.2727272727,148.8636363636,148,147.4545454545,147.5,147.3181818182,147.3181818182,147.6818181818,147.4090909091,147.4545454545,147.8636363636,148.1818181818,148.4090909091,148.3636363636,148.6818181818,148.8636363636,149.5,149.5909090909,149.3181818182,149.0909090909,149.1363636364,149.5909090909,150.3636363636,151.6818181818,152.7727272727,154.2727272727,151.6279069767,152.9302325581,154.4186046512,155.9534883721,157.8604651163,159.3953488372,160.6046511628,161.4418604651,162.8837209302,164.0930232558,165.7209302326,168,171.7674418605,174.0465116279,177.5813953488,179.8604651163,182.2325581395,184.4186046512,186.5581395349,188.1860465116,189.9069767442,191.6744186047,194.3255813953,195.5813953488,197.1162790698,198.511627907,199.3023255814,199.3953488372,200.0465116279,201.1627906977,202.1395348837,203.1162790698,204.6046511628,205.6279069767,205.488372093,204.976744186,205.5348837209,206.3720930233,207.3953488372,210,208.7804878049,208.6829268293,210.2564102564,209.2820512821,208.7692307692,210.2702702703,209.3333333333,208,206.5714285714,205.6470588235,204.5294117647,194.7,196,195.5,194.625,192.75,190.625,187.8666666667,186,184.6666666667,182.8,188,186.7692307692,184.1538461538,181.5384615385,178.3076923077,177.0909090909};
		int p312_arr_length = 97;
		double[] p316_bgl_arr = {162.9473684211,163.3684210526,163.3684210526,163.3684210526,163.5789473684,163.2631578947,163.5789473684,163.6842105263,163.5789473684,163.1578947368,163.1578947368,163.4736842105,164.1052631579,165.2631578947,165.6842105263,166.2105263158,167.7894736842,169.3684210526,170.5263157895,171.2631578947,171.6842105263,172,172.1052631579,171.8947368421,172.4210526316,172.3157894737,172.4210526316,172,171.6842105263,171.6842105263,171.2631578947,171.5789473684,171.1578947368,170.6315789474,169.3684210526,168.9473684211,168.7368421053,168.5263157895,168.1052631579,167.2631578947,166.4210526316,166.2105263158,166.8421052632,166,166.6315789474,168.4444444444,168.8888888889,167.7777777778,172.2352941176,170.8235294118,171.0588235294,170,170,170,171.125,170.2857142857,170.4285714286,169.8571428571,170,169.7142857143,164.7692307692,164.7692307692,163.6923076923,163.3846153846,162.6153846154,160.6666666667,155.8,152.6,151.6,150.2,149.8,149.2};
		int p316_arr_length = 72;
		int first_index = time_asleep / 5;
		int second_index = predict_time / 5;

		double difference;

		if(pid == 301)
		{
			if(first_index < p301_arr_length)
			{
				if(second_index < p301_arr_length)
				{
					difference = p301_bgl_arr[second_index];
				}
				else
				{
					difference = p301_bgl_arr[p301_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 304)
		{
			if(first_index < p304_arr_length)
			{
				if(second_index < p304_arr_length)
				{
					difference = p304_bgl_arr[second_index];
				}
				else
				{
					difference = p304_bgl_arr[p304_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 306)
		{
			if(first_index < p306_arr_length)
			{
				if(second_index < p306_arr_length)
				{
					difference = p306_bgl_arr[second_index];
				}
				else
				{
					difference = p306_bgl_arr[p306_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 310)
		{
			if(first_index < p310_arr_length)
			{
				if(second_index < p310_arr_length)
				{
					difference = p310_bgl_arr[second_index];
				}
				else
				{
					difference = p310_bgl_arr[p310_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 312)
		{
			if(first_index < p312_arr_length)
			{
				if(second_index < p312_arr_length)
				{
					difference = p312_bgl_arr[second_index];
				}
				else
				{
					difference = p312_bgl_arr[p312_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 316)
		{
			if(first_index < p316_arr_length)
			{
				if(second_index < p316_arr_length)
				{
					difference = p316_bgl_arr[second_index];
				}
				else
				{
					difference = p316_bgl_arr[p316_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else
		{
			System.out.println("Error pid not found: ");
			System.out.println(pid);
			difference = 0.0;
		}

		evector.vector.add(difference);
	}
	else
	{
     		evector.vector.add(0.0);
    	}
  }


//dawn phenomenon feature, using the difference between the average bgl for that patient after that amount of time of sleep and the arima prediction

  public void compute_arima_dawn_p(int pred_time)
  {

    	if(DBUtil.op_is_asleep(gc))
	{
		int time_asleep = DBUtil.op_time_asleep(gc);
		int predict_time = time_asleep + pred_time;
		double[] p304_bgl_arr = {3.94507104765957,2.68989872851064,2.44945781914894,1.70702410914894,0.881941507021277,-1.13078297255319,-3.25102545829787,-4.85104854659575,-1.65134706021277,0.729446972978723,-0.967577345744681,5.06428575914894,2.62883545680851,0.193103651276596,-2.66941383638298,-0.613232846595745,-0.313787388510638,-0.321999320425532,2.45134679957447,2.90252656212766,1.52874449978723,1.38521826212766,0.0374338161702131,-1.16399201808511,-3.07870191468085,-5.30396706659574,-2.05089237914894,-1.32123070510638,-0.655675917659574,-0.367632583617021,-0.572855951489362,-0.226851232978723,-0.430457625319149,0.130932540638298,1.04040238617021,1.17329589659574,0.798174408085106,0.352295521914893,1.10673837255319,1.19453454382979,-0.0988525672340426,2.10211145744681,2.87319207510638,3.05372081595745,2.46629497787234,3.05701298297872,3.43568262914894,0.42123328893617,-1.28588231702128,-1.19582224361702,-0.676972743617021,-1.92163011553191,-2.62497415617021,-2.48358457893617,2.79466751468085,0.113155684893616,0.259702185434783,-0.216785631956521,2.51082832456522,2.92402815173913,4.59573330511111,6.382509502,4.72507791466667,4.74201237227273,3.35889074534884,1.9069819672093,1.36203939953488,-4.22861813395349,-2.26911192767442,-3.02239601139535,-1.02455724395349,-0.0494037067441858,1.10838108690476,2.31162472309524,3.86829669357143,3.76565905761905,2.32437712619048,2.24070977926829,2.61345471540541,3.08042242916667,1.69658218972222,2.04974631885714,1.90746701857143,1.62790772314286,0.21436965483871,-1.21685664032258,-1.48341185451613,-0.609875864,0.451260127333333,1.054894351,0.89132744,4.37819108555556,1.86643269423077,2.53414459565217,1.27407063086956,1.99608288130435,4.847450074,-18.162771554,-8.95041486133333,-6.83090706916667,-4.56753342909091,-3.68989950636364};
		int p304_arr_length = 102;
		double[] p306_bgl_arr = {-6.84203878794872,-8.53561087076923,-7.96470829307692,-6.16818591589744,-5.06102113435897,-3.93770599205128,-2.51353544076923,-0.450537337179487,1.7711608225641,2.75518456076923,3.27112545948718,2.57794442333333,2.98862521871795,2.16314922,1.79406491615385,2.41565615410256,2.2063748274359,2.46492777,1.91944665333333,4.02002929487179,4.19588652948718,6.02588148410257,8.51143902307692,10.167648595641,10.4092814202564,10.6979375253846,10.6948486966667,11.4536556915385,13.1014002417949,9.36520561692308,8.89432043512821,7.30842407769231,8.0380502074359,8.56690580153846,8.6143579425641,8.43540953128205,6.82381258230769,6.05666181153846,5.82766572974359,6.48603294410256,6.72232283846154,7.09283711717949,6.22792727358974,5.00792566512821,2.92442177410256,1.91224344230769,1.78617656025641,2.70251627179487,4.07486570923077,3.37688126948718,4.05408182717949,4.69679850923077,2.7356042925641,1.17141666820513,0.766131815641024,2.9325661574359,2.60212844846154,0.982063818974359,0.64908717,0.563161382820513,-0.966314962564103,-2.25364362589744,-2.44691470076923,-1.85902647179487,-2.12720311692308,-2.57444413205128,-0.109891827435897,-0.684606288157894,1.22881181216216,2.41492411108108,3.40345884777778,4.26683755657143,5.11701038964286,4.09734588952381,-7.39241302857143,-5.839448195,-3.91722357,-3.24051387,-2.60537248947368,-5.12822721578947,-4.1493717,-4.30547253157895,-10.2093125666667,-9.06387571666667,-9.29342258333333,-6.54272478888889,-6.43658592222222,-6.78861330555556,-5.47881075555556,-4.73013471666667,-4.46934808882353,-4.994236938,-3.54346156533333,-3.297323676,-2.86506647,-3.86672049428571};
		int p306_arr_length = 96;
		double[] p310_bgl_arr = {-3.36512076263158,-2.6906396345614,-4.46227753350877,-6.87068600210526,-5.8752468377193,-8.37628227736842,-8.50170714122807,-9.01893675263158,-6.08666961,-4.33376628859649,-7.56316947578947,-5.8504779122807,-6.05173286526316,-2.20656747789474,-2.95231362438596,-2.0069375377193,-0.080467896140351,0.0253744661403503,2.28348235684211,-0.478111395614035,1.2453460622807,2.45061798245614,0.112379941403509,-2.21682046649123,-4.1665415145614,-5.4778801531579,-5.31959582175439,-3.25322337192983,-2.38448932649123,-2.10239729350877,-1.95718533315789,-2.4784009722807,-2.53981579578947,-2.88527599842105,-1.39975498614035,0.661581364035089,2.65170069982456,4.59207065631579,3.87676197403509,3.23868703947368,3.39624555842105,2.85452289508772,2.62011761438596,3.79031894947369,4.20426127,4.0246382131579,2.69473751912281,3.14641036719298,2.42708384280702,2.50911901736842,1.83262965631579,1.2802766422807,-0.839770094912281,0.0742335191228068,1.32293582578947,2.05243358368421,2.14451046438597,1.56494793192982,0.899512109824561,0.581792035964912,-0.412515664035088,-0.177867521403509,0.502587362631579,1.02480204105263,1.92763125280702,2.00756519842105,2.71475333482143,2.71703989571429,1.83318013803571,1.11233573660714,1.33911376571429,2.44668081964286,1.58607983555556,1.27441406490566,0.958821857358491,1.52325706,1.56270779134615,2.14714712019231,2.12275661574468,1.78587964,2.303777058,1.982892155,1.45509797681818,1.46733547977273,3.98691733205128,3.48421280194445,2.41117620722222,3.17878173617647,1.37680456117647,-0.0435046085294119,-3.1451408062069,-3.96814522555555,-6.87506013555556,-6.71401385384615,-4.81895161730769,-3.20899521346154,-0.946483164583333,-1.48226455833333,0.0716161844444452,-1.38157627529412,-7.27083218133333,-8.97055081,-11.73802015,-16.342634109,-15.897657423};
		int p310_arr_length = 105;
		double[] p312_bgl_arr = {-5.38361457068182,-5.18985742795455,-8.35949599,-7.33972957727273,-6.08724352909091,-5.02544384318182,-3.05613242181818,-1.33805924863636,-0.116633922272727,0.462676732045454,-1.86367781340909,0.436398128181818,0.618252355227274,0.634231505681818,0.695436728409091,0.448963344318182,0.334718201136363,-0.122656465681818,0.97968739,0.777788241363636,0.386903526818182,-0.681865197954545,-0.984524329772727,-1.13052326227273,-2.53875630159091,-1.70036170522727,-2.12959845568182,-0.379337992727273,1.05957621840909,2.9963517075,3.66804173,5.07143898767442,5.64696288744186,4.75058566651163,5.94330877697675,5.43914114209302,5.62066001186046,5.17042482139535,4.87869291930232,5.05439250046512,3.93122759627907,4.62463968325581,7.79370645093023,9.95063507744186,10.9579160325581,12.7021973553488,13.3583659344186,12.8621609504651,9.80168092790698,10.6700242930233,7.67129074883721,7.5793353744186,7.66613294418605,6.65340312790698,6.21148672325581,6.45893063255814,5.77306185348837,5.22121290232558,2.57420658837209,4.02472988139535,3.85585292790698,3.52888439767442,5.074604,7.22347501860465,5.30591296904762,2.87563992380952,3.28130712619048,3.25414258333333,2.98776534761905,3.86792195641026,5.06680891794872,6.19661847692308,4.54753838918919,1.35305213243243,0.0592501702702702,-1.6985595,-1.99588586285714,-3.06246469428571,-3.16388852058824,0.535112254545454,-1.37330483333333,-0.19949747,-0.31721150625,1.4136078875,-0.21594529375,-1.7704724,-3.4394585375,-3.4876404,-5.02596445,-6.86837089285714,-7.04689392142857,-4.02255170833333,-2.339691975,-1.41012905,-2.9052077,-5.33399213333333,-5.48274021};
		int p312_arr_length = 97;
		double[] p316_bgl_arr = {-2.82820400157895,-3.24103696,-2.60509092105263,-3.24854171578947,-3.14669418947368,-1.66542532105263,-3.30084172631579,-4.66929660526316,-4.81475588421053,-6.33937910526316,-7.73946727894737,-7.675583,-6.16410757894737,-4.58914055789474,-2.71933860526316,-0.490150789473684,2.32015778421053,3.49263117368421,2.79954487894737,1.83762538421053,2.96664946315789,1.2294645631579,-4.76957902631579,-8.75303668421053,-5.56241179444444,-5.57884027222222,-4.49626329722222,-4.84967693,-4.39415975111111,-4.20149458944445,-5.57498412388889,-4.39088698388889,-5.19868981722222,-4.44087985888889,-4.26226191555556,-5.71231566277778,-4.98132279444444,-6.16735013277778,-5.151672245,-4.48314490388889,-2.99835957722222,-3.65260537888889,-3.03655644777778,-3.59362169944444,-0.809645253333333,0.277828214444444,2.91741255666667,1.22582573666667,0.0245584506250004,2.353594081875,-0.989546006249999,3.2954561625,-1.5034067375,1.712918325,1.5384139875,4.77971312142857,3.50607010714286,4.36673434285714,3.35219461428571,1.74049805,-2.03533675384615,0.199626430769231,-1.22372043846154,0.625186046153846,0.512021238461538,-2.19864240909091,0.435432560000001,-5.63820558,-3.09744564,-5.01908903,-6.79634281,-6.61082511};
		int p316_arr_length = 72;
		int first_index = time_asleep / 5;
		int second_index = predict_time / 5;

		double difference;

		
		if(pid == 304)
		{
			if(first_index < p304_arr_length)
			{
				if(second_index < p304_arr_length)
				{
					difference = p304_bgl_arr[second_index];
				}
				else
				{
					difference = p304_bgl_arr[p304_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 306)
		{
			if(first_index < p306_arr_length)
			{
				if(second_index < p306_arr_length)
				{
					difference = p306_bgl_arr[second_index];
				}
				else
				{
					difference = p306_bgl_arr[p306_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 310)
		{
			if(first_index < p310_arr_length)
			{
				if(second_index < p310_arr_length)
				{
					difference = p310_bgl_arr[second_index];
				}
				else
				{
					difference = p310_bgl_arr[p310_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 312)
		{
			if(first_index < p312_arr_length)
			{
				if(second_index < p312_arr_length)
				{
					difference = p312_bgl_arr[second_index];
				}
				else
				{
					difference = p312_bgl_arr[p312_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 316)
		{
			if(first_index < p316_arr_length)
			{
				if(second_index < p316_arr_length)
				{
					difference = p316_bgl_arr[second_index];
				}
				else
				{
					difference = p316_bgl_arr[p316_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else
		{
			System.out.println("Error pid not found: ");
			System.out.println(pid);
			difference = 0.0;
		}

		evector.vector.add(difference);
	}
	else
	{
     		evector.vector.add(0.0);
    	}
  }

//dawn phenomenon feature, using the average physiologically predicted bgl for that patient after that amount of time of sleep
  public void compute_phys_dawn_p(int pred_time)
  {

    	if(DBUtil.op_is_asleep(gc))
	{
		int time_asleep = DBUtil.op_time_asleep(gc);
		int predict_time = time_asleep + pred_time;
		double[] p304_bgl_arr = {137.363178083813, 137.602776200998, 136.757544604874, 135.074283947681, 134.007023365155, 131.320560434496, 130.085172043609, 129.030407630156, 129.198853689987, 128.425954764448, 127.646840852894, 127.301018229876, 126.457012136697, 127.066317952679, 128.0982385518, 128.784035403988, 129.926709480965, 131.034612799128, 132.439378785516, 133.838506827278, 132.922526363595, 132.293892835013, 131.494644449877, 130.819746336023, 130.519854823796, 130.643624785658, 131.101870598357, 131.277834898404, 131.37766558851, 131.52862581005, 131.880181803389, 132.290789618498, 132.315438819307, 132.368799094609, 133.100669101825, 133.37725856872, 133.656628839138, 133.934798267546, 134.192759417818, 134.221890259991, 134.270847207995, 135.718231085517, 136.237629434294, 136.613529297265, 136.721322474289, 137.48281364359, 137.964785185757, 138.224769061438, 137.076201336321, 137.058025219914, 137.351499769536, 137.601094154458, 137.361056899553, 137.436770688838, 137.141701072578, 136.993500843573, 134.639673454867, 134.97264814204, 136.240291349086, 136.815116165844, 136.867610493187, 138.190041357826, 138.129611477942, 138.246347568042, 139.201434536532, 138.834302455697, 138.273539198106, 137.76642024133, 137.122350901909, 136.923219449643, 137.422223781982, 137.803915809373, 138.624443393526, 139.095305268783, 139.9090499217, 140.280019141122, 140.463537865842, 139.780070912026, 140.819918797049, 141.544928940707, 141.413119522878, 139.999791841611, 139.125801956087, 138.008864527469, 138.49520573983, 137.037237587978, 137.032723791992, 135.437191648513, 134.91964970256, 134.035315042909, 133.94990534464, 135.715214130308, 132.55133233867, 133.093476891147, 132.75699173982, 132.008642106792, 125.795034865353, 125.36054095276, 124.834635090403, 125.782551571692, 125.954652082231, 127.224176466969, 120.550222928611};
		int p304_arr_length = 103;
		double[] p306_bgl_arr = {118.058775102557, 117.462393603595, 116.826725521284, 116.437923696039, 116.476446640486, 117.275285166495, 118.424613998989, 120.049831133427, 121.768819070041, 122.909157968221, 124.134171765872, 125.582414791712, 128.005448531441, 129.644716357183, 131.450507986889, 132.900393928621, 133.860381445105, 134.999076828913, 136.718345121653, 138.705766090344, 140.693486684455, 142.239031069066, 143.311097007449, 145.925328877707, 148.519674869554, 151.754413698416, 153.945608622404, 155.627961054758, 157.338767388689, 158.812763347066, 160.729759294847, 162.168706440095, 163.723630367734, 164.78971591113, 165.78482406669, 166.133503600092, 166.566506483461, 166.903752139574, 167.283908291454, 167.336057642026, 167.39471739468, 167.23874516212, 166.408382016235, 165.552993292094, 164.523893154259, 164.166810975814, 164.611364972121, 165.494869502906, 166.405408057202, 165.752501649731, 166.076284751367, 166.636620881965, 166.757051238999, 166.932500004542, 167.15223683548, 167.577743096277, 167.753159143336, 167.497772804081, 167.058581474167, 166.349504086983, 165.114069196257, 163.884050589669, 163.013619223079, 161.779226707619, 160.712917087189, 159.837484070651, 160.009088278755, 157.249581047775, 157.969406388378, 158.722247127631, 162.662873436324, 168.355631909521, 175.069589546755, 176.742211522295, 176.116609190148, 175.863487252171, 177.455706973945, 177.123704617676, 177.231992858646, 174.679499189336, 172.452123080603, 170.447012369421, 172.966755656803, 170.315044848767, 167.550357637262, 165.440804407843, 163.280522753782, 161.783426501414, 161.421746017435, 161.086458655493, 158.048732380592, 160.482956971102, 160.140050768794, 160.849679683513, 154.227985354364, 156.36764470672 };
		int p306_arr_length = 96;
		double[] p310_bgl_arr = {86.0707225650901, 85.7990065819496, 84.4989163775759, 82.9691167976155, 83.1427104763316, 83.3537452005005, 83.5599082322852, 83.2320656033772, 83.4799801227167, 83.1827659614613, 82.5470781792552, 82.5027859754229, 82.1835260832948, 83.5305421288071, 83.7767042477111, 83.7792621021247, 84.6766611824057, 85.7746693235959, 86.9760980643325, 88.2359543767626, 89.0431415644226, 89.2971376885587, 89.8068455973106, 89.9586720445655, 89.9466057349061, 90.2190067649709, 90.6230385797021, 91.5304487068994, 91.9833170345365, 92.0004781654781, 92.2348671489205, 91.9715603178386, 92.3848138646843, 93.0104442606451, 94.1032267896689, 95.3337562003216, 96.5041784852893, 96.6716671071238, 96.6245882255837, 96.6767415137043, 97.0452519854284, 97.0123456237157, 97.159735099114, 97.0966217870919, 97.0911434137139, 97.2842339986333, 98.0741992660778, 98.5047125760341, 98.4431940005026, 98.1550568531629, 97.911702968634, 98.0386013514265, 98.2764835082955, 98.6893379117162, 99.3330888671307, 100.065538848636, 100.697019834546, 101.438654445024, 102.115235257898, 102.877590916999, 103.711622395603, 104.044283976313, 104.536012666225, 105.171521215321, 105.625317954382, 105.601055795526, 106.795487077787, 107.108245646483, 107.275109849164, 107.325167126139, 107.683865317733, 108.368580971596, 109.257990383551, 109.905504447574, 110.379484806605, 111.72206104946, 112.401319151332, 113.054901872632, 114.841499965876, 115.786391224519, 115.267047766602, 115.693208637355, 115.660245076235, 115.883565728833, 120.602787279552, 120.332480807684, 120.143527095533, 122.437649067886, 122.291200917466, 120.806439732956, 121.152675715411, 124.244013444505, 122.65941777682, 120.059863168702, 119.772626015478, 119.245327056865, 117.287267181716, 104.47442771627, 103.743083212218, 104.236202406796, 102.692089682879, 102.319462763417, 93.9186011998811, 94.1176963940803, 93.4474672706853};
		int p310_arr_length = 105;
		double[] p312_bgl_arr = {121.240042171221, 119.678224917877, 118.435321062296, 117.716440980896, 118.339794677672, 117.95626058349, 117.73822467227, 117.870167048925, 118.453006530308, 119.085749665549, 119.750209288883, 120.559308996493, 120.849349460539, 121.491552157156, 122.738009170062, 123.917463107578, 124.867566636205, 125.727729270208, 126.903149722561, 127.748955787656, 129.051666102001, 129.686461592171, 130.214897204121, 130.607326050556, 131.293063180058, 132.540287830054, 134.121908940977, 136.209936344469, 137.907243961601, 140.168883938693, 138.034461976547, 139.925906905675, 141.888127929685, 143.942851903824, 146.289272131387, 148.086461921284, 149.693946430025, 150.741482890605, 152.413558684413, 153.753976735949, 155.330082886892, 157.368789054687, 160.866965308694, 162.892383730164, 165.944782979998, 167.803577208672, 169.555203846678, 170.964365508206, 172.061275903756, 172.476185316279, 172.857011815616, 172.955935609834, 173.924002887908, 173.816624614053, 174.0446364911, 174.280493071667, 173.98123094275, 173.242111686881, 173.057582163599, 173.199763098129, 172.985249849458, 172.808970056749, 172.990319730518, 173.686613374231, 172.026687290381, 170.719107305007, 170.782205966647, 171.838494241179, 172.915507894499, 174.853451784554, 175.18884863644, 175.34498550877, 175.490433482179, 174.303211411232, 173.952553158376, 173.012599599848, 172.242855329308, 171.440413955352, 168.644481653526, 169.010421448211, 168.37277208406, 154.262229761899, 153.591623652032, 153.719750354076, 153.331014116367, 152.932184633359, 151.843803825513, 143.646218246704, 142.905284746107, 142.566487102405, 142.240392477383, 143.301624060121, 143.569116745086, 142.926473307747, 142.449194229731, 141.003727301676, 133.921726835093};
		int p312_arr_length = 97;
		double[] p316_bgl_arr = {92.5521790803328, 93.8371608111928, 94.7266915253897, 95.5022513203521, 96.551225470275, 97.4169288952511, 98.2389856622794, 98.8732897609539, 99.0261281090502, 99.0217955446319, 99.0644385014445, 99.6342754459255, 100.750462774018, 101.633913373975, 101.917049818948, 102.30049634216, 104.869755001665, 107.029558235636, 107.710798412227, 107.867135526725, 107.798394550641, 107.851169877629, 107.815094803433, 108.046811419256, 108.745455665523, 109.216964800464, 109.970584334813, 110.327093716326, 109.622264689068, 109.967739241599, 110.246273098369, 110.797208128671, 111.296486708037, 111.145969768226, 110.779796839366, 110.78528883022, 111.149776319997, 112.627100029499, 113.745772969061, 114.636678894576, 115.140603504963, 116.257599403695, 117.595192160414, 117.298104898465, 118.176711415152, 117.61277850684, 118.58782119499, 118.221029121801, 123.09100559756, 121.696546812779, 121.452088122953, 120.007387236964, 119.439689057824, 118.311602354802, 117.805335267677, 117.514221466844, 116.201843476995, 113.850550869802, 111.769743141325, 109.53471435993, 106.52431533847, 105.400714593471, 104.338096256185, 103.512788586558, 102.586317400301, 96.7000858355137, 96.1516381260247, 92.6331622186483, 91.0630113926448, 89.2312903133124, 87.7942281135244, 87.5940364681083};
		int p316_arr_length = 72;
		int first_index = time_asleep / 5;
		int second_index = predict_time / 5;

		double difference;

		
		if(pid == 304)
		{
			if(first_index < p304_arr_length)
			{
				if(second_index < p304_arr_length)
				{
					difference = p304_bgl_arr[second_index];
				}
				else
				{
					difference = p304_bgl_arr[p304_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 306)
		{
			if(first_index < p306_arr_length)
			{
				if(second_index < p306_arr_length)
				{
					difference = p306_bgl_arr[second_index];
				}
				else
				{
					difference = p306_bgl_arr[p306_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 310)
		{
			if(first_index < p310_arr_length)
			{
				if(second_index < p310_arr_length)
				{
					difference = p310_bgl_arr[second_index];
				}
				else
				{
					difference = p310_bgl_arr[p310_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 312)
		{
			if(first_index < p312_arr_length)
			{
				if(second_index < p312_arr_length)
				{
					difference = p312_bgl_arr[second_index];
				}
				else
				{
					difference = p312_bgl_arr[p312_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 316)
		{
			if(first_index < p316_arr_length)
			{
				if(second_index < p316_arr_length)
				{
					difference = p316_bgl_arr[second_index];
				}
				else
				{
					difference = p316_bgl_arr[p316_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else
		{
			System.out.println("Error pid not found: ");
			System.out.println(pid);
			difference = 0.0;
		}

		evector.vector.add(difference);
	}
	else
	{
     		evector.vector.add(0.0);
    	}
  }

//dawn phenomenon feature, using the difference between the average physiologically predicted bgl for that patient after that amount of time of sleep and the actual average
  public void compute_phys_diff_dawn_p(int pred_time)
  {

    	if(DBUtil.op_is_asleep(gc))
	{
		int time_asleep = DBUtil.op_time_asleep(gc);
		int predict_time = time_asleep + pred_time;
		double[] p304_bgl_arr = {9.14341737829787, 10.3385378729574, 11.2781684875745, 12.1027978839787, 12.9206141101064, 13.3271803520638, 13.8872431154255, 14.4885088985319, 15.1210314439362, 15.444083848383, 15.6004281301915, 15.7178129901915, 15.4311902750426, 14.6193334690213, 13.7767251444681, 12.8901589722766, 12.1059754142979, 11.3575140210425, 10.8748987812979, 10.9482627016809, 10.8649564166596, 10.7925128146809, 10.721217114383, 10.6541605080638, 10.565899434766, 10.2337904698511, 9.87166010089362, 9.48955204897872, 9.14237229008511, 8.78268974948936, 8.44214003510638, 8.34112294602128, 8.27831543934043, 8.22758569612766, 8.28114628144681, 8.3522312896383, 8.46267506195745, 8.61990742440425, 8.83695072031915, 9.06503418557447, 9.27365551085106, 9.68763513412766, 9.86130749631915, 10.0052225791064, 10.0709506438723, 10.1351250798723, 10.1346174311915, 10.0938476904255, 9.94229452882979, 9.835821629, 9.76470700619149, 9.69116424512766, 9.63151013234042, 9.64314529229787, 9.67718997697872, 9.78021282238298, 9.5982248895, 9.76155052497826, 10.0751846097174, 10.2979911351957, 10.4684958636444, 11.3873599990222, 11.4620986971778, 10.8848834477955, 10.9860896883954, 10.8941076915116, 10.7689383526047, 10.6313147694651, 10.4888717580233, 10.3626975644884, 10.2826682803953, 10.1827825566047, 10.1310283380476, 9.80538798342857, 9.56472868621429, 9.33531806954762, 9.14960213783334, 8.51151721939024, 8.65384423332433, 8.95510427394444, 9.42233284111112, 9.92607432885714, 10.5376302086857, 11.2254721546571, 13.4544936012903, 14.1195223122258, 15.0865772289355, 15.2012652662, 15.8633282633, 16.441464919, 17.6288603965, 17.8542681312222, 16.8908989351923, 16.8530515385217, 16.418633967, 15.9795230753913, 8.9972441042, 8.65825756926666, 8.1488954852, 6.19658505608333, 3.82078735963636, 1.34087054754545};
		int p304_arr_length = 100;
		double[] p306_bgl_arr = {25.6335325895128, 25.1529910118718, 24.6091719154872, 24.0236147663333, 23.4209892570513, 22.8785609870769, 22.3958988222308, 22.0014509181538, 21.6157963154359, 21.1421240831026, 20.6863410545641, 20.2637390542051, 19.7381412123846, 19.2783605659744, 18.8571843208462, 18.6380676109487, 18.2934647091282, 18.1291282997436, 18.1534497500769, 18.3198749351538, 18.5885645972821, 18.8891740595128, 19.047877351359, 19.3567224049487, 19.480325130359, 19.3225093793077, 19.0287503514359, 18.7310133044615, 18.5073864571282, 18.2641597295128, 18.0907535261026, 18.0364217648718, 17.9173952726667, 17.7231046019487, 17.5997913181538, 17.507522041, 17.5360576190513, 17.865478629, 18.4083994011538, 18.9716346664615, 19.5796415803077, 20.1971522745641, 20.7198231122308, 21.1136733736154, 21.3735427418974, 21.6280608183077, 21.8501734895385, 21.9923099841538, 22.0048483535385, 21.7859598888718, 21.6673049917949, 21.5685073235385, 21.4480769664872, 20.9136538409487, 20.4375067539487, 20.0632825446923, 19.7340203441795, 19.3740220681538, 18.9927005769231, 18.9325471945641, 18.8346487521026, 18.7826160766923, 18.8325346228718, 18.8874399580513, 18.9793906049744, 19.1368749032564, 18.6062963364359, 16.908313689, 17.7062692871622, 16.8993744938108, 12.7260154522222, 6.67293951842857, 6.14469616817857, 16.6863599054286, 15.1214860470476, 19.43651274695, 18.14429302675, 16.3762953814, 18.5574808258421, 18.2678692306842, 17.9689295513158, 17.6582507886316, 17.6999110086111, 17.3516218178889, 17.0051979175, 16.7814178145556, 16.6083661356111, 16.5499068327222, 15.2449206485556, 13.5802080118333, 13.598326443, 15.3837096951333, 14.5266158985333, 13.550320316, 13.4863003602857, 9.63235529257143};
		int p306_arr_length = 96;
		double[] p310_bgl_arr = {63.402961645, 63.4641513139298, 62.9396801149474, 61.8379007472281, 61.1029035587719, 60.3304653246316, 59.5278110651053, 58.7679343964386, 58.3445812847018, 57.5891638657895, 56.7862551540526, 56.0937052517544, 55.1498072515439, 55.732615766807, 54.9952255780351, 54.3260010560526, 54.1303563607018, 53.839365762807, 53.3396914087895, 52.7815894830351, 52.0796654534737, 51.2993535394211, 50.4738561570877, 49.6202753242982, 48.7902363703509, 48.0266072696491, 47.2716982635088, 46.7151653293684, 46.1570338433333, 45.4381183268421, 44.712501272807, 43.6775624892105, 42.8081685910877, 42.2176259150351, 41.8616854911403, 41.6136122215789, 41.4958215150175, 41.6090346463158, 41.9017275626316, 42.270626909807, 43.0950988928421, 43.8297596385263, 44.5946508661754, 45.2893431269123, 45.8913127272456, 46.4350642455789, 47.0836954707368, 47.5303751425438, 47.8725954764386, 48.1607326205614, 48.4742619440351, 48.9087670701754, 49.3024638598245, 49.7317147194737, 50.1055076231579, 49.899373432807, 49.478418762386, 49.017485907193, 48.4812559703509, 47.9294266250877, 47.4462723398246, 47.3943125126316, 47.6043382107018, 47.9161980824561, 48.1992434480351, 48.3989442040526, 48.95451292275, 49.2131829250715, 49.4034615784464, 49.4962614462321, 49.6732775378929, 49.9171333144643, 50.1864540607408, 50.1699672511321, 50.0733453822264, 50.3548620275192, 50.6371423873077, 51.2143288963462, 53.7967979059574, 55.1913865551111, 56.3329522346667, 57.8067913634091, 58.9761185604545, 59.9346160888636, 61.0895204120513, 57.7786303019444, 58.3564729027778, 60.0329391697059, 60.8264461405882, 61.4288543861765, 61.95077256, 63.8300606288889, 64.3776192585185, 65.0170599080769, 66.3042970630769, 67.6008267934615, 66.2960661508333, 58.7477945116667, 58.0346945633889, 57.9990917111177, 56.6412436533333, 55.6805372333333, 59.681398802, 57.482303609, 55.152532726};
		int p310_arr_length = 105;
		double[] p312_bgl_arr = {31.3054123740454, 30.7308659915, 30.2464971181136, 29.7381044729318, 29.2965689588182, 28.6801030539091, 28.1708662362955, 27.6752874962273, 27.2288116517727, 26.7324321521818, 26.2497907110682, 25.7588728212727, 25.1506505401591, 24.5084478429545, 23.8528999207727, 23.1279914377273, 22.3142515459545, 21.4995434572273, 20.7332139143636, 19.9328623942955, 19.2210611701136, 18.4499020445682, 17.648739159, 16.8017648585682, 15.9796640918864, 15.0506212606364, 14.0599092410227, 13.1991545652727, 12.4563924020455, 11.876570607, 11.2678636044186, 10.8182791410698, 10.4374534654419, 10.1036597240233, 9.85026275239535, 9.63446831141861, 9.46884426755814, 9.30502873746512, 9.26085992032558, 9.26927907813953, 9.36759153158139, 9.51493187534884, 9.78419748211628, 10.0843604560233, 10.5668449273488, 11.080143721093, 11.7936333627907, 12.7100530964651, 13.8457008406744, 15.1052100322326, 16.4918253936512, 17.881273692907, 19.3783226935814, 20.6950032932326, 21.9088518815349, 23.1148557663721, 24.2513271972093, 25.3160278481395, 26.4773015576744, 27.7304694593023, 28.9682385218605, 30.1677741286046, 31.3352616648837, 32.6854796490698, 32.6875984240476, 33.4713688861905, 34.0749368904762, 33.9234105206667, 33.8463968678571, 36.1209071894872, 35.9393564920256, 35.731937568359, 37.3203773283784, 36.7778696710811, 36.642041436027, 38.9874004006286, 38.9000018133143, 38.2738717586857, 39.6496359946177, 38.9895785525758, 38.4151067044849, 42.4377702395, 44.908376350625, 44.280249647125, 43.54398588425, 42.3178153675, 40.78119617625, 44.4966388919286, 43.3804295385714, 42.2906557578572, 40.7596075242857, 45.5317092741667, 43.9308832561667, 42.0735266916667, 40.3841391008333, 38.6629393658333, 45.278273165};
		int p312_arr_length = 97;
		double[] p316_bgl_arr = {66.9215051294737, 66.2681023456842, 65.4838347911053, 64.8135381559474, 64.3961429524211, 64.0567553155263, 63.7610143339474, 63.4424997141579, 62.9738718892632, 62.557151825, 62.1987193958421, 62.0499350823158, 62.1969056452632, 62.3660866268947, 62.3987396567895, 63.2784510266316, 63.8670870999474, 64.4441259786316, 64.7102542192105, 64.8697065767368, 64.9384475562105, 64.8856722291579, 64.6059578288947, 64.2689780556842, 61.9212110006111, 61.5608129806111, 61.2516378866111, 60.7840173931667, 61.3777353112222, 61.0322607578889, 60.6426157905556, 60.2027918732778, 59.7035132908333, 59.0762524558333, 58.4424253827778, 57.8813778372222, 57.4057792338889, 55.8173444144444, 54.3653381420555, 53.0299877741111, 51.7482853844444, 50.7424005961667, 49.8492522836111, 49.8130062128333, 50.1566219172778, 50.1649992706111, 50.5232899157222, 50.6678597666667, 51.533994401875, 52.0534531875, 53.04791187625, 53.86761276375, 55.060310941875, 56.438397644375, 58.1946647315625, 58.7714928188571, 60.9410136623571, 63.0065919866429, 65.0873997092857, 66.7509999292857, 65.6295308184615, 66.4454392430769, 66.8926729776923, 67.71798064, 68.7982979846154, 66.7544596209091, 70.048361878, 70.766837788, 71.536988612, 71.568709692, 71.405771879, 71.605963534};
		int p316_arr_length = 72;
		int first_index = time_asleep / 5;
		int second_index = predict_time / 5;

		double difference;

		
		if(pid == 304)
		{
			if(first_index < p304_arr_length)
			{
				if(second_index < p304_arr_length)
				{
					difference = p304_bgl_arr[second_index];
				}
				else
				{
					difference = p304_bgl_arr[p304_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 306)
		{
			if(first_index < p306_arr_length)
			{
				if(second_index < p306_arr_length)
				{
					difference = p306_bgl_arr[second_index];
				}
				else
				{
					difference = p306_bgl_arr[p306_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 310)
		{
			if(first_index < p310_arr_length)
			{
				if(second_index < p310_arr_length)
				{
					difference = p310_bgl_arr[second_index];
				}
				else
				{
					difference = p310_bgl_arr[p310_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 312)
		{
			if(first_index < p312_arr_length)
			{
				if(second_index < p312_arr_length)
				{
					difference = p312_bgl_arr[second_index];
				}
				else
				{
					difference = p312_bgl_arr[p312_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else if(pid == 316)
		{
			if(first_index < p316_arr_length)
			{
				if(second_index < p316_arr_length)
				{
					difference = p316_bgl_arr[second_index];
				}
				else
				{
					difference = p316_bgl_arr[p316_arr_length - 1];
				}
			}
			else
			{
				difference = 0.0;
			}
		}
		else
		{
			System.out.println("Error pid not found: ");
			System.out.println(pid);
			difference = 0.0;
		}

		evector.vector.add(difference);
	}
	else
	{
     		evector.vector.add(0.0);
    	}
  }


}
