import Diabetes.DataObjects.Reading;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;
import util.DateUtil;
import util.InputUtil;
import BGPredict.PredictionConfig;
import BGPredict.Experiment;
/**
 * This class calls the prediction system via a command line interface
 */
public class Command_line 
{
	public static void main(String[] argv) throws IOException
	{
		for(int i = 0; i < argv.length; i++)
		{
			if(argv[i].equals("-t"))
			{
				i++;
				PredictionConfig.SetLookahead(Integer.parseInt(argv[i]));
			}
			else if(argv[i].equals("-o"))
			{
				i++;
				PredictionConfig.SetOutput(argv[i]);
			}
			else if(argv[i].equals("-w"))
			{
				i++;
				PredictionConfig.SetWindow(Integer.parseInt(argv[i]));
			}
			else if(argv[i].equals("-s"))
			{
				i++;
				if(Integer.parseInt(argv[i]) == 1)
				{
					PredictionConfig.SetScale(true);
				}
				else
				{
					PredictionConfig.SetScale(false);
				}
			}
			else if(argv[i].equals("-k"))
			{
				i++;
				if(argv[i].equals("g"))
				{
					PredictionConfig.SetKernel("GAUSSIAN");
				}
				else
				{
					PredictionConfig.SetKernel("LINEAR");
				}
			}
			else if(argv[i].equals("-d"))
			{
				i++;
				PredictionConfig.SetDataset(argv[i]);
			}
			else if(argv[i].equals("-c"))
			{
				i++;
				PredictionConfig.SetC(Double.parseDouble(argv[i]));
			}
			else if(argv[i].equals("-p"))
			{
				i++;
				PredictionConfig.SetP(Double.parseDouble(argv[i]));
			}
			else if(argv[i].equals("-g"))
			{
				i++;
				PredictionConfig.SetG(Double.parseDouble(argv[i]));
			}
			else
			{
				System.out.println("error parsing command line");
				System.out.println(argv[i]);
			}
		}

		Experiment exp = new Experiment();
                exp.run_p();
                exp.printResults_p();
	}
}
