package Diabetes.DataObjects;

import java.util.GregorianCalendar;

/**
 * Represents a Bolus reading
 * @author Matthew Wiley
 * @since 1-5-10
 */
public class BolusReading extends Reading implements Comparable<Reading> {

    public BolusReading(GregorianCalendar t) {
        super(t);
    }

    public BolusReading(GregorianCalendar t, String type, double dose, double bwz_est, double selected) {
        super(t);
        this.type = type;
        this.bwz_est = bwz_est;
        this.selected = selected;
        this.dose = dose;
        this.duration = 0;
    }
    private double dose;
    private double bwz_est;
    private double selected;
    private String type;
    private double duration;

    public double getDuration() {
        return duration;
    }

    public void setDuration(double duration) {
        this.duration = duration;
    }

    
    public double getBwz_est() {
        return bwz_est;
    }

    public double getDose() {
        return dose;
    }

    public double getSelected() {
        return selected;
    }

    public String getType() {
        return type;
    }
}
