package Diabetes.DataObjects;

import java.util.GregorianCalendar;

/**
 * A data object used by DailySchedule for holding meals and work information, for a particular day.
 * @author Matthew Wiley
 * @version 1.0
 * @since Jun 8, 2010
 */
public class DailyScheduleInfo {

    /**
     *
     * @param start
     * @param end
     */
    public DailyScheduleInfo(GregorianCalendar start, GregorianCalendar end) {
        this.start = start;
        this.end = end;
    }

    /**
     *
     * @param start
     * @param end
     * @param breakfast
     * @param lunch
     * @param dinner
     */
    public DailyScheduleInfo(GregorianCalendar start, GregorianCalendar end, GregorianCalendar breakfast, GregorianCalendar lunch, GregorianCalendar dinner) {
        this.start = start;
        this.end = end;
        this.breakfast = breakfast;
        this.lunch = lunch;
        this.dinner = dinner;
    }

    /**
     *
     * @return start time
     */
    public GregorianCalendar getEnd() {
        return end;
    }

    /**
     *
     * @return end time
     */
    public GregorianCalendar getStart() {
        return start;
    }

    /**
     *
     * @return time of breakfast
     */
    public GregorianCalendar getBreakfast() {
        return breakfast;
    }

    /**
     *
     * @return time of dinner
     */
    public GregorianCalendar getDinner() {
        return dinner;
    }

    /**
     *
     * @return time of lunch
     */
    public GregorianCalendar getLunch() {
        return lunch;
    }

    private GregorianCalendar start;
    private GregorianCalendar end;
    private GregorianCalendar breakfast;
    private GregorianCalendar lunch;
    private GregorianCalendar dinner;
}
