package Diabetes.DataObjects;

import java.util.GregorianCalendar;
import util.DateUtil;

/**
 * Represents a CGMS reading with a timestamp and value
 * @author Matthew Wiley
 * @since 11-20-10
 */
public class Reading  implements Comparable<Reading> {

    public Reading(GregorianCalendar t) {
        this.t = t;
    }

    public Reading(GregorianCalendar t, double value) {
        this.value = value;
        this.t = t;
    }

    public Reading(Reading o) {
        this.value = o.value;
        this.t = DateUtil.copyGC(o.t);
    }

    public double getValue() {
        return value;
    }

    public GregorianCalendar getT() {
        return t;
    }

    public boolean isValid() {
        return valid;
    }

    public void setValid(boolean valid) {
        this.valid = valid;
    }
    public void setValue(double val){
        this.value = val;
    }
    protected double value;
    protected GregorianCalendar t;
    private boolean valid = false;

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof Reading)) {
            return false;
        }
        if (this.t.compareTo(((Reading) obj).getT()) == 0) {
            return true;
        }
        return false;
    }

    @Override
    public int hashCode() {
        final int multiplier = 23;
        if (hashCode == 0) {
            int code = 132;
            code = multiplier * code + t.hashCode();
            hashCode = code;
        }
        return hashCode;
    }

    @Override
    public int compareTo(Reading o) {
        return t.compareTo(o.getT());
    }
    private volatile int hashCode = 0;
}
