

import Diabetes.DataObjects.Reading;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;
import util.DateUtil;
import util.InputUtil;
import BGPredict.PredictionConfig;
import BGPredict.Experiment;
/**
 * This class runs the main menu used for predicting blood glucose values.
 */
public class Menu {

    

    public static void main(String[] argv) throws IOException{
        boolean done = false;
        String menu_message = "Prediction Experiment Menu\n"
                + "   Enter A to configure the experiment\n"
                + "   Enter B to run the experiment\n"
                + "   Enter C to generate the ARIMA values\n"
		+ "   Enter D to generate the tuning files\n"
                + "   Enter Q to quit\n\n";
        Pattern opts = null;
        String choice = null;
        Scanner scan = new Scanner(System.in);
        while (!done) {
            System.out.println(menu_message);
            opts = Pattern.compile("^([aAbBcCdDqQ])$");
            choice = InputUtil.getInput(scan, opts).toUpperCase();
            if (choice.equals("Q")) {
                done = true;
            }else if(choice.equals("A")){
                PredictionConfig.Configure();
            }else if(choice.equals("B")){
                Experiment exp = new Experiment();
                exp.run_p();
                exp.printResults_p();
            }else if(choice.equals("C")){
            	Experiment exp = new Experiment();
            	exp.arima();
            }else if(choice.equals("D")){
            	Experiment exp = new Experiment();
            	exp.run_tuning_p();
	    }
            
            
        }
    }

}
